VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Arry"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Public Enum arADDTO
    arTOBEGIN = 1
    arTOEND = 2
    arADDTOINDEX = 3
End Enum

Public Function Compare(sArray1 As Variant, sArray2 As Variant, _
                        Optional ErrorNumber As Long) As Boolean
    Dim P As Long, V1 As Long, V2 As Long
    
    On Local Error GoTo Quit
    
    ErrorNumber = 0

    V1 = LBound(sArray1)
    V2 = LBound(sArray2)
    
    If V1 = -1 And V2 = -1 Then
        Compare = True
        
        Exit Function
    End If
                                
    If (UBound(sArray1) <> UBound(sArray2)) Or _
       (LBound(sArray1) <> LBound(sArray2)) Then Exit Function
    
    For P = LBound(sArray1) To UBound(sArray1)
        If sArray1(P) <> sArray2(P) Then Exit Function
    Next P
    
    Compare = True
    
    Exit Function
    
Quit:
    ErrorNumber = Err.Number
        
    Call ERROR(Array_, "Compare", Err.Number, Err.Description)
        
    Err.Clear
    
End Function
Public Function Find(ByVal sArray As Variant, _
                     ByVal ToFind As Variant, _
                     Optional StartIndex = -1, _
                     Optional EndIndex As Long = -1, _
                     Optional FindExact As Boolean = False, _
                     Optional ErrorNumber As Long) As Long
    Dim P As Long, sI As Long, eI As Long
    
    On Local Error GoTo Quit
    
    ErrorNumber = 0
    
    If Not FindExact Then ToFind = LCase$(ToFind)
        
    If StartIndex > -1 Then
        sI = StartIndex
    Else
        sI = LBound(sArray)
    End If
    
    If EndIndex > -1 Then
        eI = EndIndex
    Else
        eI = UBound(sArray)
    End If
    
    For P = sI To eI
        If IIf(FindExact, CStr(sArray(P)), _
                          CStr(LCase$(sArray(P)))) = CStr(ToFind) Then Find = P: _
                                                                       Exit Function
    Next P
        
    Find = -1
    
    Exit Function
    
Quit:
    ErrorNumber = Err.Number
    Find = -2
    
    Call ERROR(Array_, "Find", Err.Number, Err.Description)
        
    Err.Clear
    
End Function
Public Function Shuffle(sArray As Variant) As Long
    Dim I As Long, X As Long, Y As Long, Z As Long
    Dim A As Variant, B As Variant
        
    On Local Error GoTo Quit
    
    A = sArray
    B = sArray
    
    Y = LBound(A)
        
    Do
        Z = LBound(A) + 1
        If Z > UBound(A) Then Z = UBound(A)
        
        X = DLL.MISC.Get_Randomize(UBound(A), Z)
        
        B(Y) = A(X)
        Y = Y + 1
        
        If X <> UBound(A) Then
            For I = X To UBound(A) - 1
                A(I) = A(I + 1)
            Next I
        End If
        
        If UBound(A) <= LBound(A) Then
            For I = LBound(B) To UBound(B)
                sArray(I) = B(I)
            Next I
            
            Exit Do
        Else
            ReDim Preserve A(UBound(A) - 1)
        End If
    Loop
    
    Exit Function
    
Quit:
    Shuffle = Err.Number
    
    Call ERROR(Array_, "Shuffle", Err.Number, Err.Description)
        
    Err.Clear
    
End Function
Public Function Sort(sArray As Variant, Optional sBubbleSort As Boolean = False) As Long
    Dim frm As New MyControls
    Dim X As Long
    
    On Local Error GoTo Quit
    
    If sBubbleSort Then
        X = CLng(BubbleSort(sArray))
        
        If X = -1 Then X = 0
        Sort = X
    Else
        Load frm
        frm.Tag = "Sort"
    
        If DLL.LB.AddArray(frm.sLB, sArray, True) = 0 Then
            Sort = DLL.LB.ToArray(frm.sLB, sArray, False)
        End If
    End If
    
Quit:
    Sort = Err.Number
        
    If Err.Number <> 0 Then Call ERROR(Array_, "Sort", Err.Number, Err.Description)
    
    Unload frm
    Set frm = Nothing

    Err.Clear

End Function
Public Function ToString(sArray As Variant, Optional ErrorNumber As Long) As Variant
    Dim P As Long
    Dim A() As String
    
    On Local Error GoTo Quit
    
    ErrorNumber = 0

    ReDim A(LBound(sArray) To UBound(sArray))
    
    For P = LBound(sArray) To UBound(sArray)
        A(P) = CStr(sArray(P))
    Next P
    
    ToString = A
    
    Exit Function
    
Quit:
    ErrorNumber = Err.Number

    Call ERROR(Array_, "ToString", Err.Number, Err.Description)
        
    Err.Clear
    
End Function
Public Function AddFromLBCB(LBCB As Object, sArray As Variant, _
                            Optional Preserv As Boolean = False) As Long
    Dim P As Long
    Dim A() As String, B() As String
    
    On Local Error GoTo Quit
    
    If LBCB.ListCount < 1 Then Exit Function
    
    ReDim A(LBCB.ListCount - 1)
       
    For P = 0 To LBCB.ListCount - 1
        A(P) = LBCB.List(P)
    Next P
    
    If Preserv Then
        B = sArray
        Call AddArray(B, A, arTOEND)
        A = B
        
        Erase B
    End If
    
    sArray = A
    
    Exit Function
    
Quit:
    AddFromLBCB = Err.Number
    
    Erase A
    sArray = A
    
    Call ERROR(Array_, "AddFromLBCB", Err.Number, Err.Description)
        
    Err.Clear
    
End Function
Public Function DeleteIndex(sArray As Variant, ByVal Index As Long) As Long
    Dim P As Long, X As Long
    Dim A As Variant, B As Variant
    
    On Local Error GoTo Quit
    
    A = sArray
    
    If UBound(sArray) = 0 And Index = 0 Then
        Erase A
    Else
        B = A
        ReDim B(UBound(A) - 1)
        
        X = 0
                
        For P = 0 To UBound(A)
            If P <> Index Then
                B(X) = sArray(P)
                
                X = X + 1
            End If
        Next P
    
        A = B
        Erase B
    End If
    
    sArray = A

    Exit Function

Quit:
    DeleteIndex = Err.Number
    
    Call ERROR(Array_, "DeleteIndex", Err.Number, Err.Description)
    
    Err.Clear
    
End Function
Public Function RemoveIndex(sArray As Variant, ByVal Index As Long) As Long
    
    RemoveIndex = DeleteIndex(sArray, Index)

End Function
Public Function DeleteValue(sArray As Variant, ByVal Value As Variant, _
                            Optional DeleteAll As Boolean = False) As Long
    Dim X As Long
    
    On Local Error GoTo Quit
    
    Do While X <= UBound(sArray)
        If CStr(sArray(X)) = CStr(Value) Then
            Call DeleteIndex(sArray, X)
            
            If Not DeleteAll Then Exit Do
            
            If X = 0 And UBound(sArray) = 0 Then
                Erase sArray
                
                Exit Do
            End If
        Else
            X = X + 1
        End If
    Loop
    
    Exit Function
    
Quit:
    DeleteValue = Err.Number
    
    Call ERROR(Array_, "DeleteValue", Err.Number, Err.Description)
    
    Err.Clear
    
End Function
Public Function AddArray(sArray1 As Variant, ByVal sArray2 As Variant, _
                         AddTo As arADDTO, Optional ByVal Index As Long = -1) As Long
    Dim P As Long, L2 As Long, X As Long, U As Long
    Dim sArray3 As Variant, sArray4 As Variant
    
    On Local Error GoTo Quit

    AddArray = Get_LBound(sArray2, AddArray)
    If AddArray < 0 Then Exit Function
    
    L2 = AddArray
    AddArray = 0
    
    U = Get_UBound(sArray1)
    
    If U = -2 Then
        AddArray = -3
        Exit Function
    End If
    
    Select Case AddTo
        Case arTOEND
            If U = -1 Then
                U = UBound(sArray2)
            
                ReDim sArray1(U)
                
                For P = 0 To U
                    sArray1(P) = sArray2(P)
                Next P
                
                Exit Function
            End If
                
            X = UBound(sArray2) - L2 + 1
            
            ReDim Preserve sArray1(LBound(sArray1) To (UBound(sArray1) + X))
            
            X = 1
            
            For P = L2 To UBound(sArray2)
                sArray1(U + X) = sArray2(P)
                X = X + 1
            Next P
            
            Exit Function
        Case arTOBEGIN
            If U = -1 Then
                ReDim sArray1(L2)
                
                For P = 0 To L2
                    sArray1(P) = sArray2(P)
                Next P
                
                Exit Function
            End If
        
            sArray3 = sArray2
            
            AddArray = AddArray(sArray3, sArray1, arTOEND)
            
            If AddArray <> 0 Then Exit Function
            
            sArray1 = sArray3
            
            Exit Function
        Case arADDTOINDEX
            If Index > (U + 1) Then
                AddArray = -4
                
                Exit Function
            End If
            
            If Index = (U + 1) Then
                AddArray = AddArray(sArray1, sArray2, arTOEND)
                
                Exit Function
            End If
        
            If Index = 0 Then
                AddArray = AddArray(sArray1, sArray2, arTOBEGIN)
            
                Exit Function
            End If
        
            ReDim sArray3(Index - 1)
            
            For P = LBound(sArray1) To (Index - 1)
                sArray3(P) = sArray1(P)
            Next P
            
            ReDim sArray4(UBound(sArray1) - Index)
                        
            X = Index
            
            For P = 0 To UBound(sArray4)
                sArray4(P) = sArray1(X)
                X = X + 1
            Next P
            
            AddArray = AddArray(sArray3, sArray2, arTOEND)
            
            If AddArray <> 0 Then Exit Function
            
            AddArray = AddArray(sArray3, sArray4, arTOEND)
            
            If AddArray <> 0 Then Exit Function
            
            Erase sArray1
            
            AddArray = AddArray(sArray1, sArray3, arTOEND)
            
            Exit Function
    End Select
    
    Exit Function
    
Quit:
    AddArray = Err.Number
    
    Call ERROR(Array_, "AddArray", Err.Number, Err.Description)
    
    Err.Clear
    
End Function
Public Function CountItem(sArray As Variant, ByVal Item As String, _
                          Optional FindExact As Boolean = True, _
                          Optional ErrorNumber As Long) As Long
    Dim P As Long, X As Long
    
    On Local Error GoTo Quit
    
    ErrorNumber = 0
    
    If Not FindExact Then Item = LCase$(Item)
    
    For P = LBound(sArray) To UBound(sArray)
        If IIf(FindExact, CStr(sArray(P)), CStr(LCase$(sArray(P)))) = Item Then X = X + 1
    Next P
    
    CountItem = X
      
    Exit Function
      
Quit:
    ErrorNumber = Err.Number
    CountItem = -1
    
    Call ERROR(Array_, "CountItem", Err.Number, Err.Description)
        
    Err.Clear
    
End Function
Public Function IsDouble(sArray As Variant, ByVal Value As String, _
                         Optional FindExact As Boolean = True, _
                         Optional ErrorNumber As Long) As Boolean
    Dim P As Long, X As Long
    Dim R$
    
    On Local Error GoTo Quit
    
    ErrorNumber = 0
    
    If Not FindExact Then Value = LCase$(Value)
    
    For P = LBound(sArray) To UBound(sArray)
        R$ = IIf(FindExact, sArray(P), LCase$(sArray(P)))
    
        If R$ = Value Then
            X = X + 1
            
            If X > 1 Then
                IsDouble = True
                
                Exit Function
            End If
        End If
    Next P
    
    Exit Function
    
Quit:
    ErrorNumber = Err.Number
    
    Call ERROR(Array_, "IsDouble", Err.Number, Err.Description)
    
    Err.Clear
    
End Function
Public Function Exist(sArray As Variant, ByVal Value As String, _
                      Optional FindExact As Boolean = False, _
                      Optional ErrorNumber As Long) As Boolean
    
    Exist = (Find(sArray, Value, , , FindExact, ErrorNumber) > -1)

End Function
Public Function Fill(sArray As Variant, ByVal Value As Variant, _
                     Optional sStart As Long = -1, Optional sEnd As Long = -1) As Long
    Dim P As Long, X As Long, Y As Long
    
    On Local Error GoTo Quit
    
    If sStart > -1 And sEnd > -1 Then
        X = sStart
        Y = sEnd
    Else
        X = LBound(sArray)
        Y = UBound(sArray)
    End If
    
    For P = X To Y
        sArray(P) = Value
    Next P
        
    Exit Function
    
Quit:
    Fill = Err.Number
    
    Call ERROR(Array_, "Fill", Err.Number, Err.Description)
    
    Err.Clear
    
End Function
Public Function Array_WriteToFile(sArray As Variant, _
                                  ByVal File As String) As Long
    Dim P As Long, X As Long
    Dim R$
    
    On Local Error GoTo Quit
    
    X = Get_LBound(sArray)
    If X < 0 Then Exit Function
    
    For P = X To UBound(sArray)
        R$ = R$ & sArray(P) & vbCrLf
    Next P
    
    If Len(R$) Then R$ = mID$(R$, 1, Len(R$) - 2)
    
    Array_WriteToFile = DLL.TEXT.TextFile_WriteText(File, R$)
            
    Exit Function
    
Quit:
    Array_WriteToFile = Err.Number
    
    Call ERROR(Array_, "Array_WriteToFile", Err.Number, Err.Description)

    Err.Clear
    
End Function
Public Function AddToLBCB(sArray As Variant, LBCB As Object, _
                          Optional AllowDouble As Boolean = True, _
                          Optional ClearBeforeAdding As Boolean = True) As Long
    
    AddToLBCB = DLL.LB.AddArray(LBCB, sArray, AllowDouble, ClearBeforeAdding)

End Function
Public Function Add(TargetArray As Variant, ByVal Value As Variant, _
                    AddTo As arADDTO, Optional Index As Long = -1, _
                    Optional AllowDouble As Boolean = True) As Long
    Dim R() As Variant
    Dim P As Long
    
    On Local Error GoTo Quit
    
    If isDIM(TargetArray) Then
        If Not AllowDouble Then
            For P = LBound(TargetArray) To UBound(TargetArray)
                If CStr(TargetArray(P)) = CStr(Value) Then
                    Add = -1
                
                    Exit Function
                End If
            Next P
        End If
    End If
    
    ReDim R(0)
    R(0) = Value
    
    Add = AddArray(TargetArray, R, AddTo, Index)

    Exit Function
    
Quit:
    Add = Err.Number

    Call ERROR(Array_, "Add", Err.Number, Err.Description)
    
    Err.Clear

End Function
Public Function Copy(sArray1 As Variant, sArray2 As Variant) As Long
    Dim P As Long
    
    On Local Error Resume Next
    
    sArray2 = sArray1
    
    If Err.Number = 0 Then Exit Function
    
    Err.Clear
    
    On Local Error GoTo Quit
    
    ReDim sArray2(LBound(sArray1) To UBound(sArray1))
    
    For P = LBound(sArray1) To UBound(sArray1)
        sArray2(P) = sArray1(P)
    Next P
    
    Exit Function
    
Quit:
    Copy = Err.Number
    
    Call ERROR(Array_, "Copy", Err.Number, Err.Description)
    
    Err.Clear
    
End Function
Public Function Get_MaxValue(sArray As Variant, Optional Value As String, _
                             Optional ErrorNumber As Long) As Long
    Dim P As Long
    
    On Local Error GoTo Quit
    
    ErrorNumber = 0
    Value = ""

    For P = LBound(sArray) To UBound(sArray)
        If CStr(sArray(P)) > CStr(Value) Then
            Get_MaxValue = P
            Value = CStr(sArray(P))
        End If
    Next P
        
    Exit Function
    
Quit:
    ErrorNumber = Err.Number
    Get_MaxValue = -2
    
    Call ERROR(Array_, "Get_MaxValue", Err.Number, Err.Description)
        
    Err.Clear
    
End Function
Public Function Get_MinValue(sArray As Variant, Optional Value As String, _
                             Optional ErrorNumber As Long) As Long
    Dim P As Long
    
    On Local Error GoTo Quit
    
    ErrorNumber = 0
    
    Get_MinValue = LBound(sArray)
    Value = sArray(LBound(sArray))
    
    For P = (LBound(sArray) + 1) To UBound(sArray)
        If CStr(sArray(P)) < CStr(Value) Then
            Get_MinValue = P
            Value = CStr(sArray(P))
        End If
    Next P
    
    Exit Function
    
Quit:
    ErrorNumber = Err.Number
    Get_MinValue = -2
    
    Call ERROR(Array_, "Get_MinValue", Err.Number, Err.Description)
        
    Err.Clear
    
End Function
Public Function FindPhrase(sArray As Variant, ByVal Find As String, _
                           Optional StartIndex As Long = -1, Optional EndIndex As Long = -1, _
                           Optional FindAtStart As Boolean = False, _
                           Optional FindExact As Boolean = True, _
                           Optional ErrorNumber As Long) As Long
    Dim P As Long, X As Long, sI As Long, eI As Long
    Dim R$
    
    On Local Error GoTo Quit
    
    ErrorNumber = 0
    FindPhrase = -1
    
    If Not FindExact Then Find = LCase$(Find)
    
    If StartIndex > -1 Then
        sI = StartIndex
    Else
        sI = LBound(sArray)
    End If
    
    If EndIndex > -1 Then
        eI = EndIndex
    Else
        eI = UBound(sArray)
    End If
        
    For P = sI To eI
        R$ = IIf(FindExact, sArray(P), LCase$(sArray(P)))
        X = InStr(R$, Find)
        
        If (FindAtStart And X = 1) Or (Not FindAtStart And X > 0) Then
            FindPhrase = P
            
            Exit Function
        End If
    Next P
        
    Exit Function
    
Quit:
    ErrorNumber = Err.Number
    FindPhrase = -2
    
    Call ERROR(Array_, "FindPhrase", Err.Number, Err.Description)
        
    Err.Clear
    
End Function
Public Function isArray(Var As Variant) As Boolean
    Dim X As Long
    
    On Local Error Resume Next
    
    X = LBound(Var)
    
    isArray = (Err.Number = 0 Or Err.Number = 9)
    
    Err.Clear
    
End Function
Public Function isDIM(sArray As Variant) As Boolean
    
    If Get_LBound(sArray) > -1 Then isDIM = True

End Function
Public Function Get_LBound(sArray As Variant, Optional ErrorNumber As Long) As Long
    Dim X As Long
    
    On Local Error Resume Next
    
    ErrorNumber = 0
    
    X = LBound(sArray)
    
    Select Case Err.Number
        Case 0:    Get_LBound = X
                   Exit Function
        Case 9:    Get_LBound = -1
                   Err.Clear
                   Exit Function
        Case 13:   Get_LBound = -2
    End Select
    
    ErrorNumber = Err.Number
    
    Err.Clear
    
End Function
Public Function Get_UBound(sArray As Variant, Optional ErrorNumber As Long) As Long
    Dim X As Long
    
    On Local Error Resume Next
    
    ErrorNumber = 0
    
    X = UBound(sArray)
    
    Select Case Err.Number
        Case 0:    Get_UBound = X
                   Exit Function
        Case 9:    Get_UBound = -1
                   Err.Clear
                   Exit Function
        Case 13:   Get_UBound = -2
    End Select
    
    ErrorNumber = Err.Number
    
    Err.Clear
    
End Function
Public Function Array_ReadFromFile(ByVal File As String, _
                                   Optional ErrorNumber As Long) As String()
    Dim A() As String, R$

    ErrorNumber = 0
    Erase A
  
    R$ = DLL.TEXT.TextFile_Read(File, ErrorNumber)
    
    If ErrorNumber <> 0 Then Exit Function
    
    A = Split(R$, vbCrLf)
    
    Array_ReadFromFile = A
    
    Exit Function
    
Quit:
    ErrorNumber = Err.Number
    
    If Err.Number <> 0 Then Call ERROR(Array_, "Array_Read", Err.Number, Err.Description)
    
    Err.Clear
        
End Function
Public Function Array_Swap(Array1 As Variant, Array2 As Variant) As Long
    Dim A As Variant
    
    Array_Swap = Copy(Array1, A)
    If Array_Swap <> 0 Then Exit Function
    
    Array_Swap = Copy(Array2, Array1)
    If Array_Swap <> 0 Then Exit Function
    
    Array_Swap = Copy(A, Array2)
    
End Function
Public Function Convert(sArray As Variant, TypeOutput As ConvertType, _
                        Optional ErrorNumber As Long) As Variant
    Dim U As Long, P As Long, LB As Long, X As Long
    Dim V() As Variant
    Dim L() As Long
    Dim S() As String
    Dim B() As Byte
    Dim D() As Date
    Dim SG() As Single
    Dim I() As Integer
    Dim CU() As Currency
    Dim DU() As Double
    
    On Local Error GoTo Quit
    
    U = Get_UBound(sArray, X)
    
    If U < 0 Then
        ErrorNumber = X
        
        Exit Function
    End If
    
    LB = LBound(sArray)
    
    Select Case TypeOutput
        Case coLong:     ReDim L(LB To U)
                         For P = LB To U
                            L(P) = sArray(P)
                         Next P
                         Convert = L
        Case coVarriant: ReDim V(LB To U)
                         For P = LB To U
                            V(P) = sArray(P)
                         Next P
                         Convert = V
        Case coString:   ReDim S(LB To U)
                         For P = LB To U
                            S(P) = sArray(P)
                         Next P
                         Convert = S
        Case coByte:     ReDim B(LB To U)
                         For P = LB To U
                            B(P) = sArray(P)
                         Next P
                         Convert = B
        Case coDate:     ReDim D(LB To U)
                         For P = LB To U
                            D(P) = sArray(P)
                         Next P
                         Convert = D
        Case coSingle:   ReDim SG(LB To U)
                         For P = LB To U
                            SG(P) = sArray(P)
                         Next P
                         Convert = SG
        Case coInteger:  ReDim I(LB To U)
                         For P = LB To U
                            I(P) = sArray(P)
                         Next P
                         Convert = I
        Case coCurrency: ReDim CU(LB To U)
                         For P = LB To U
                            CU(P) = sArray(P)
                         Next P
                         Convert = CU
        Case coDouble:   ReDim DU(LB To U)
                         For P = LB To U
                            DU(P) = sArray(P)
                         Next P
                         Convert = DU
        Case Else:       Exit Function
    End Select
        
    Exit Function
    
Quit:
    ErrorNumber = Err.Number
    
    Call ERROR(Array_, "Convert", Err.Number, Err.Description)
    
    Err.Clear

End Function
Public Function RemoveDouble(sArray As Variant, _
                             Optional FindExact As Boolean = True) As Long
    Dim sArray2 As Variant
    Dim X As Long, P As Long, Index As Long
    Dim R$, S$
    Dim Found As Boolean
    
    On Local Error GoTo Quit
    
    RemoveDouble = Copy(sArray, sArray2)
    If RemoveDouble <> 0 Then Exit Function
    
    Index = 0
    
    Erase sArray
    
    For P = LBound(sArray2) To UBound(sArray2)
        R$ = IIf(FindExact, sArray2(P), LCase$(sArray2(P)))
        Found = False
        
        If Index = 0 Then
            ReDim sArray(0)
            sArray(0) = sArray2(P)
        
            Index = 1
        Else
            For X = LBound(sArray) To UBound(sArray)
                S$ = IIf(FindExact, sArray(X), LCase$(sArray(X)))
                
                If S$ = R$ Then
                    Found = True
                    Exit For
                End If
            Next X
        
            If Not Found Then
                ReDim Preserve sArray(Index)
                sArray(Index) = sArray2(X)
                
                Index = Index + 1
            End If
        End If
    Next P

    Exit Function

Quit:
    RemoveDouble = Err.Number
    
    Call ERROR(Array_, "RemoveDouble", Err.Number, Err.Description)
    
    Err.Clear
    
End Function
Public Function RemoveValue(sArray As Variant, ByVal Value As String, _
                            Optional FindExact As Boolean = True) As Long
    Dim Index As Long, P As Long
    Dim R$
    
    On Local Error GoTo Quit
    
    RemoveValue = Get_UBound(sArray)
    If RemoveValue < 0 Then Exit Function
    
    Index = RemoveValue
    RemoveValue = 0
    
    Value = IIf(FindExact, Value, LCase$(Value))
    
    For P = Index To LBound(sArray) Step -1
        R$ = IIf(FindExact, sArray(P), LCase$(sArray(P)))
        
        If R$ = Value Then Call DeleteIndex(sArray, P)
    Next P
    
    Exit Function
    
Quit:
    RemoveValue = Err.Number

    Call ERROR(Array_, "RemoveValue", Err.Number, Err.Description)
    
    Err.Clear

End Function
Public Function Replace(sArray As Variant, Found As String, _
                        ReplaceWith As String) As Long
    Dim P As Long, X As Long
    
    Replace = Get_LBound(sArray)
    
    If Replace < 0 Then Exit Function
        
    For P = LBound(sArray) To UBound(sArray)
        If CStr(sArray(P)) = Found Then
            sArray(P) = ReplaceWith
        
            X = X + 1
        End If
    Next P

    Replace = X

End Function
Public Function Array_ReadBinary(ByVal File As String, _
                                 Optional ErrorNumber As Long) As Variant
    Dim FN As Integer
    Dim R As Variant
    
    On Local Error GoTo Quit
    
    ErrorNumber = 0
    
    FN = FreeFile()
    
    Open File For Binary As #FN
        Get #FN, 1, R
    Close #FN

    Array_ReadBinary = R
    
    Exit Function
    
Quit:
    ErrorNumber = Err.Number
    
    Call ERROR(Array_, "Array_ReadBinary", Err.Number, Err.Description)
    
    Err.Clear

End Function
Public Function Array_SaveBinary(sArray As Variant, ByVal File As String, _
                                 Optional DeleteExistingFile As Boolean = True, _
                                 Optional ErrorNumber As Long) As Boolean
    Dim FN As Integer
    
    On Local Error GoTo Quit
    
    ErrorNumber = 0
    
    If DLL.File.Exist(File) Then
        If Not DeleteExistingFile Then Exit Function
    End If
    
    Call DLL.File.fKill(File)
    
    FN = FreeFile()
    
    Open File For Binary As #FN
        Put #FN, 1, sArray
    Close #FN
  
    Array_SaveBinary = True
  
    Exit Function
    
Quit:
    ErrorNumber = Err.Number
        
    Call ERROR(Array_, "Array_SaveBinary", Err.Number, Err.Description)
    
    Err.Clear

End Function
Public Function RemoveEmpty(sArray As Variant) As Long
    
    RemoveEmpty = RemoveValue(sArray, "", True)

End Function
Public Function Array_Invert(sArray As Variant, _
                             Optional ErrorNumber As Long) As Variant
    Dim P As Long, Index As Long, X As Long
    Dim A() As String
    
    On Local Error GoTo Quit
    
    ErrorNumber = 0
    
    Index = Get_UBound(sArray)
    
    If Index < 0 Then Exit Function
    
    ReDim A(Index)
    
    X = 0
    
    For P = Index To LBound(sArray) Step -1
        A(X) = sArray(P)
        X = X + 1
    Next P
    
    Array_Invert = A

    Exit Function

Quit:
    ErrorNumber = Err.Number
    
    Call ERROR(Array_, "Array_Invert", Err.Number, Err.Description)
    
    Err.Clear
    
End Function
