VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Controls"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Private Declare Function IsClipboardFormatAvailable Lib "user32" (ByVal wFormat As Long) As Long
Private Declare Function GetClipboardData Lib "user32" (ByVal wFormat As Long) As Long
Private Declare Function DragQueryFile Lib "shell32.dll" Alias "DragQueryFileA" (ByVal hDrop As Long, ByVal UINT As Long, ByVal lpStr As String, ByVal ch As Long) As Long
Private Declare Function CloseClipboard Lib "user32" () As Long
Private Declare Function smSetColor Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Private Declare Function BitBlt Lib "gdi32" (ByVal hDestDC As Long, ByVal X As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) As Long
Private Declare Function SetBKColor Lib "gdi32" Alias "SetBkColor" (ByVal hDC As Long, ByVal crColor As Long) As Long
Private Declare Function PathCompactPath Lib "shlwapi" Alias "PathCompactPathA" (ByVal hDC As Long, ByVal lpszPath As String, ByVal dx As Long) As Long
Private Declare Function RegisterClipboardFormat Lib "user32" Alias "RegisterClipboardFormatA" (ByVal lpString As String) As Long
Private Declare Function SetClipboardData Lib "user32" (ByVal wFormat As Long, ByVal hMem As Long) As Long
Private Declare Function EmptyClipboard Lib "user32" () As Long
Private Declare Function PrintDlg Lib "comdlg32.dll" Alias "PrintDlgA" (pPrintdlg As PRINTDLG_TYPE) As Long
Private Declare Function GetWindowText Lib "user32" Alias "GetWindowTextA" (ByVal hwnd As Long, ByVal lpString As String, ByVal cch As Long) As Long
Private Declare Function ShowScrollBar Lib "user32.dll" (ByVal hwnd As Long, ByVal wBar As Long, ByVal bShow As Long) As Long
Private Declare Function GdiplusStartup Lib "GDIPlus" (token As Long, inputbuf As GdiplusStartupInput, Optional ByVal outputbuf As Long = 0) As Long
Private Declare Function GdipCreateBitmapFromHBITMAP Lib "GDIPlus" (ByVal hBM As Long, ByVal hPal As Long, BITMAP As Long) As Long
Private Declare Function CLSIDFromString Lib "ole32" (ByVal Str As Long, ID As GUID) As Long
Private Declare Function GdipSaveImageToFile Lib "GDIPlus" (ByVal Image As Long, ByVal Filename As Long, clsidEncoder As GUID, encoderParams As Any) As Long
Private Declare Function GdipDisposeImage Lib "GDIPlus" (ByVal Image As Long) As Long
Private Declare Function GdiplusShutdown Lib "GDIPlus" (ByVal token As Long) As Long
Private Declare Function InitCommonControlsEx Lib "comctl32.dll" (ByRef iccInit As ICCEX) As Long
Private Declare Function RedrawWindow Lib "user32" (ByVal hwnd As Long, lprcUpdate As Any, ByVal hrgnUpdate As Long, ByVal fuRedraw As Long) As Long

Private Declare Sub CopyMem Lib "kernel32" Alias "RtlMoveMemory" (Destination As Any, Source As Any, ByVal Length As Long)

Public Enum ListViewSort
    lsSortByNumASCending = 1
    lsSortByDateASCending = 2
    lsSortByNumDEScending = 4
    lsSortByDateDEScending = 8
    
    lsSortASCending = 16
    lsSortDEScending = 32
End Enum

Public Enum ControlAnimatePosition
    caLeftTop = 0
    caLeftMiddle = 1
    caLeftBottom = 2
    caRightTop = 4
    caRightMiddle = 8
    caRightBottom = 16
    caMiddleTop = 32
    caMiddleMiddle = 64
    caMiddleBottom = 128
End Enum

Private Type TOOLINFO
    cbSize   As Long
    dwFlags  As Long
    hwnd     As Long
    dwID     As Long
    rtRect   As RECT
    hInst    As Long
    lpszText As Long
    lParam   As Long
End Type

Private Type ICCEX
    dwSize As Long
    dwICC  As Long
End Type

Private Type GUID
    Data1    As Long
    Data2    As Integer
    Data3    As Integer
    Data4(7) As Byte
End Type

Private Type EncoderParameter
    GUID           As GUID
    NumberOfValues As Long
    Type           As Long
    Value          As Long
End Type

Private Type EncoderParameters
    Count     As Long
    Parameter As EncoderParameter
End Type

Private Type GdiplusStartupInput
    GdiplusVersion           As Long
    DebugEventCallback       As Long
    SuppressBackgroundThread As Long
    SuppressExternalCodecs   As Long
End Type

Public Type CONTROLDIMENSIONS
    Height As Long
    Width  As Long
End Type

Public Type CONTROLPOSITION
    Left   As Long
    Top    As Long
    Right  As Long
    Bottom As Long
End Type

Public Type COMMONDIALOGINFO
    hwnd     As Long
    Flags    As COMMONDIALOGFLAGS
    Filter   As String
    XPos     As Long
    YPos     As Long
End Type

Public Enum ControlDirection
    cdHorizontal = 0
    cdVertical = 1
End Enum

Public Enum COMMONDIALOGFLAGS
    cdSHOWSAVE = 0
    cdSHOWOPEN = 1
    cdSHOWFONT = 2
    cdSHOWCOLOR = 3
    cdSHOWPRINTER = 4
End Enum

Public Enum TREEVIEWINFO
    tvKEY = 2
    tvTEXT = 4
    tvTAG = 8
End Enum

Public Enum FLEXALIGMENT
    alCENTERBOTTOM = 5
    alCENTERCENTER = 4
    alCENTERTOP = 3
    alGENERAL = 9
    alLEFTBOTTOM = 2
    alLEFTCENTER = 1
    alLEFTTOP = 0
    alRIGHTBOTTOM = 8
    alRIGHTCENTER = 7
    alRIGHTTOP = 6
End Enum

Public Enum FLEXSORT
    flGENERICASCENDING = 1
    flGENERICDESCENDING = 2
    flSORTNONE = 0
    flNUMERICASCENDING = 3
    flNUMERICDECENDING = 4
    flSTRINGASCENDING = 7
    flSTRINGDESCENDING = 8
    flSTRINGNOCASEASCENDING = 5
    flSTRINGNOCASEDESCENDING = 6
End Enum

Public Enum STYLE
    crGRAFICSTYLE = 0
    crSTANDARDSTYLE = 1
End Enum

Public Enum KEYEVENT
    kyKEYDOWN = 0
    kyCHANGE = 1
End Enum

Public Enum RGBCOLOR
    rgRED = 1
    rgGREEN = 2
    rgBLUE = 3
End Enum

Private Type NODEINFO
    LinkId   As Long
    TEXT     As String
    Key      As Variant
    Expanded As Boolean
    Sorted   As Long
    Tag      As Variant
    Selected As Boolean
End Type

Private Type PRINTDLG_TYPE
    lStructSize         As Long
    hWndOwner           As Long
    hDevMode            As Long
    hDevNames           As Long
    hDC                 As Long
    Flags               As Long
    nFromPage           As Integer
    nToPage             As Integer
    nMinPage            As Integer
    nMaxPage            As Integer
    nCopies             As Integer
    hInstance           As Long
    lCustData           As Long
    lpfnPrintHook       As Long
    lpfnSetupHook       As Long
    lpPrintTemplateName As String
    lpSetupTemplateName As String
    hPrintTemplate      As Long
    hSetupTemplate      As Long
End Type

Dim m_cTT As clsTooltip

Dim ghWndTip As Long, ghWndParent As Long

Public Function TextBox_AllowNumOnly(TextBox As Object, tbEvent As KEYEVENT, _
                                     Optional DigitsAfterDecimal As Long = 0, _
                                     Optional KeyCode As Integer, _
                                     Optional HelpOnF1 As Boolean = True, _
                                     Optional SetToolTip As Boolean = True) As Long
    Dim A As String, K As String, T As String, S$, H As String, O$
    Dim X As Long, P As Long
    Dim Found As Boolean
    
    On Local Error GoTo Quit
       
    If SetToolTip Then _
        H = "In diesem Eingabefeld sind nur Zahlen erlaubt" & _
            IIf(HelpOnF1, " (F1 fr Hilfe)", ""): _
            TextBox.ToolTipText = H
        
    A = IIf((DigitsAfterDecimal > 0), ",", "")
    
    T = TextBox.TEXT
    O$ = T
        
    Select Case tbEvent
        Case kyCHANGE
            For P = 1 To Len(T)
                Select Case mID$(T, P, 1)
                    Case "0" To "9"
                        S$ = S$ & mID$(T, P, 1)
                    Case A
                        If Not Found Then
                            S$ = S$ & mID$(T, P, 1)
                            
                            Found = True
                        End If
                End Select
            Next P
            
            T = S$
            
            Do While Left$(T, 1) = ","
                T = mID$(T, 2)
            Loop
            
            X = InStr(T, ",")
            
            If X > 0 Then
                If Len(T) - X > DigitsAfterDecimal Then
                    T = mID$(T$, 1, X + DigitsAfterDecimal)
                End If
            End If
            
            If O$ <> T Then TextBox.TEXT = T
        Case kyKEYDOWN
            If KeyCode = 46 Or KeyCode = 8 Or KeyCode = 13 Or KeyCode = 37 Or _
               KeyCode = 38 Or KeyCode = 39 Or KeyCode = 40 Then Exit Function
            
            If KeyCode = 27 Then
                TextBox.TEXT = ""
                
                Exit Function
            End If
               
            If HelpOnF1 And KeyCode = 112 Then
                T = "Eingabefeld Hilfe"
                H = "In diesem Eingabefeld sind nur Zahlen zulssig." & vbCrLf & vbCrLf & _
                    "Folgende Zeichen sind erlaubt:" & vbCrLf & vbCrLf & Num
                
                If DigitsAfterDecimal > 0 Then
                    H = H & " sowie ein "","" und " & DigitsAfterDecimal & _
                        " Ziffern nach dem "",""."
                End If
                
                H = H & vbCrLf & vbCrLf & "ESC lscht das Eingabefeld." & vbCrLf

                MsgBox H, vbInformation + vbOKOnly, T
                
                Exit Function
            End If
                         
            K = Chr$(KeyCode)
            X = InStr(T, ",")
            
            If InStr(Num & A, K) = 0 Then
                KeyCode = 0
                
                If (K = ",") And ((X <> 0) Or (Len(T) = 0)) Then KeyCode = 0
            End If
    End Select
      
    Exit Function
    
Quit:
    TextBox_AllowNumOnly = Err.Number
    
    If Err.Number <> 0 Then Call ERROR(Controls, "TextBox_AllowNumOnly", Err.Number, Err.Description)

    Err.Clear
    
End Function
Public Function TextBox_AllowAlphaOnly(TextBox As Object, tbEvent As KEYEVENT, _
                                       Optional KeyCode As Integer, _
                                       Optional LAlpha As Boolean = True, _
                                       Optional UAlpha As Boolean = True, _
                                       Optional Space As Boolean = True, _
                                       Optional AllowedChar As String = "", _
                                       Optional HelpOnF1 As Boolean = True, _
                                       Optional SetToolTip As Boolean = True) As Long
    Dim S$, T As String, H As String, R$
    Dim P As Long
    
    On Local Error GoTo Quit
    
    If SetToolTip Then
        H = "In diesem Eingabefeld sind nur Alphanumerische Eingaben zulssig." & _
            IIf(HelpOnF1, " (F1 fr Hilfe)", "")
            
        TextBox.ToolTipText = H
    End If
    
    T = TextBox.TEXT
        
    If LAlpha Then R$ = lABC
    If UAlpha Then R$ = R$ & uABC
    If Space Then R$ = R$ & Chr$(32)
    R$ = R$ & AllowedChar

    Select Case tbEvent
        Case kyCHANGE
            For P = 1 To Len(T)
                If InStr(R$, mID$(T, P, 1)) > 0 Then S$ = S$ & mID$(T, P, 1)
            Next P
            
            If T <> S$ Then
                TextBox.TEXT = S$
                TextBox.SelStart = Len(S$)
                TextBox.SelLength = 0
            End If
        Case kyKEYDOWN
            If KeyCode = 46 Or KeyCode = 8 Or KeyCode = 13 Or KeyCode = 37 Or _
               KeyCode = 38 Or KeyCode = 39 Or KeyCode = 40 Then Exit Function
            
            If KeyCode = 27 Then
                TextBox.TEXT = ""
                
                Exit Function
            End If
               
            If HelpOnF1 And KeyCode = 112 Then
                T = "Eingabefeld Hilfe"
                H = "In diesem Eingabefeld sind nur Alphanumerische Eingaben zulssig." & vbCrLf & vbCrLf & _
                    "Folgende Zeichen sind erlaubt:" & vbCrLf & vbCrLf & R$ & vbCrLf
                    
                If Space Then H = H & "Sowie Freizeichen" & vbCrLf
                
                H = H & vbCrLf & "ESC lscht das Eingabefeld." & vbCrLf
                
                MsgBox H, vbInformation + vbOKOnly, T
                
                Exit Function
            End If

            If InStr(R$, Chr$(KeyCode)) = 0 Then KeyCode = 0
    End Select
    
    Exit Function
    
Quit:
    TextBox_AllowAlphaOnly = Err.Number
    
    Call ERROR(Controls, "TextBox_AllowAlphaOnly", Err.Number, Err.Description)

    Err.Clear
    
End Function
Public Function Clipboard_GetFiles() As Variant
    Dim hDrop As Long, nFiles As Long, T As Long, Result As Long
    Dim Filename As String, A() As String
    
    On Local Error GoTo Quit
    
    If IsClipboardFormatAvailable(CF_HDROP) Then
        Call OpenClipboard(0&)
        hDrop = GetClipboardData(CF_HDROP)
        
        nFiles = DragQueryFile(hDrop, -1&, "", 0)
        
        ReDim A(nFiles - 1)

        For T = 0 To nFiles - 1
            Filename = Space(MAX_PATH)
            Result = DragQueryFile(hDrop, T, Filename, Len(Filename))
            A(T) = Left$(Filename, Result)
        Next T
    End If

Quit:
    Call CloseClipboard
    
    If Err.Number <> 0 Then
        Erase A
         
        Call ERROR(Controls, "Clipboard_GetFiles", Err.Number, Err.Description)
    End If
    
    Clipboard_GetFiles = A
        
    Err.Clear
    
End Function
Public Function Clipboard_SetPathList(Paths() As String) As Long
    Dim cbData As String
    Dim hGlobal As Long, lpGlobal As Long, I As Long, cbFormatID As Long, DropEffect As Long
    Dim DF As DROPFILES
 
    Const CFSTR_PREFERREDDROPEFFECT As String = "Preferred DropEffect"
    Const GHND = (GMEM_MOVEABLE Or GMEM_ZEROINIT)

    On Local Error GoTo Quit
    
    DropEffect = 5
 
    If OpenClipboard(0&) Then
        Call EmptyClipboard
        hGlobal = GlobalAlloc(GHND, Len(DropEffect))
    
        If hGlobal Then
            lpGlobal = GlobalLock(hGlobal)
            
            Call CopyMem(ByVal lpGlobal, DropEffect, Len(DropEffect))
            Call GlobalUnlock(hGlobal)
            
            cbFormatID = RegisterClipboardFormat(CFSTR_PREFERREDDROPEFFECT)
            
            Call SetClipboardData(cbFormatID, hGlobal)
        End If
    
        For I = LBound(Paths) To UBound(Paths)
            cbData = cbData & Paths(I) & vbNullChar
        Next I
    
        cbData = cbData & vbNullChar
        hGlobal = GlobalAlloc(GHND, Len(DF) + Len(cbData))
    
        If hGlobal Then
            lpGlobal = GlobalLock(hGlobal)
            DF.pFiles = Len(DF)
      
            Call CopyMem(ByVal lpGlobal, DF, Len(DF))
            Call CopyMem(ByVal (lpGlobal + Len(DF)), ByVal cbData, Len(cbData))
            Call GlobalUnlock(hGlobal)
            Call SetClipboardData(CF_HDROP, hGlobal)
        End If
    End If

Quit:
    Clipboard_SetPathList = Err.Number
    
    Call CloseClipboard
    
    If Err.Number <> 0 Then Call ERROR(Controls, "Clipboard_SetPathList", Err.Number, Err.Description)

    Err.Clear
    
End Function
Public Function CheckBox_SetStyle(CheckBox As Object, STYLE As STYLE) As Long
    Dim CurStyle As Long

    Const BS_PUSHLIKE = &H1000&

    On Local Error GoTo Quit

    CurStyle = GetWindowLong(CheckBox.hwnd, GWL_STYLE)

    CurStyle = IIf(STYLE = crGRAFICSTYLE, CurStyle Or _
                           BS_PUSHLIKE, CurStyle And (Not BS_PUSHLIKE))
    
    If SetWindowLong(CheckBox.hwnd, GWL_STYLE, CurStyle) Then CheckBox.Refresh

    Exit Function
    
Quit:
    CheckBox_SetStyle = Err.Number
    
    Call ERROR(Controls, "CheckBox_SetStyle", Err.Number, Err.Description)
    
    Err.Clear
    
End Function
Public Function OptionButton_SetStyle(OptionButton As Object, STYLE As STYLE) As Long
    
    OptionButton_SetStyle = CheckBox_SetStyle(OptionButton, STYLE)

End Function
Public Sub ProgressBar_SetColor(ByVal hwnd As Long, _
                                ByVal ForeColor As Long, ByVal BackColor As Long)
    
    Call smSetColor(hwnd, &H409, 0&, ForeColor)
    Call smSetColor(hwnd, &H2001, 0&, BackColor)
    
End Sub
Public Function Flex_SetColAligment(Flex As Object, ALIGMENT As FLEXALIGMENT, _
                                    Optional ColIndex As Long = -1, _
                                    Optional AllCols As Boolean = False) As Long
    Dim Col As Long, fStart As Long, fEnd As Long
    
    On Local Error GoTo Quit
    
    If AllCols Then
        fStart = 0
        fEnd = Flex.Cols - 1
    Else
        fStart = ColIndex
        fEnd = fStart
    End If
    
    For Col = fStart To fEnd
        Flex.ColAlignment(Col) = ALIGMENT
    Next Col
    
    Flex.Refresh
    DoEvents
    
    Exit Function
    
Quit:
    Flex_SetColAligment = Err.Number
    
    Call ERROR(Controls, "Flex_SetColAligment", Err.Number, Err.Description)

    Err.Clear
    
End Function
Public Function Flex_Sort(Flex As Object, _
                          Sort As FLEXSORT, ByVal ColIndex As Long) As Long
    Dim oRow As Long, oCol As Long
    
    On Local Error Resume Next
    
    With Flex
        oRow = .Row
        oCol = .Col
    
        .Row = 1
        .Col = ColIndex
    
        .Sort = Sort
    
        .Row = oRow
        .Col = oCol
        
        .Refresh
        DoEvents
    End With
    
    If Err.Number = 30009 Then Err.Clear
    Flex_Sort = Err.Number

    If Err.Number <> 0 Then Call ERROR(Controls, "Flex_Sort", Err.Number, Err.Description)

    Err.Clear
    
End Function
Public Function Flex_ColorRow(Flex As Object, _
                              ByVal ForeColor As Long, ByVal BackColor As Long, _
                              ByVal Row As Long) As Long
    Dim oRow As Long, oCol As Long, FS As Long
    Dim AB As Boolean
    
    Const flexFillRepeat = 1
        
    On Local Error GoTo Quit
    
    With Flex
        oRow = .Row
        oCol = .Col
        AB = .AllowBigSelection
        FS = .FillStyle
              
        .AllowBigSelection = True
        .FillStyle = flexFillRepeat
                
        .Row = Row
        .Col = 0
        
        .RowSel = Row
        .ColSel = .Cols - 1
        
        .CellBackColor = BackColor
        .CellForecolor = ForeColor
                
        .Row = oRow
        .Col = oCol
        
        .AllowBigSelection = AB
        .FillStyle = FS
                
        .Refresh
        DoEvents
    End With
    
    Exit Function
    
Quit:
    Flex_ColorRow = Err.Number
    
    Call ERROR(Controls, "Flex_ColorRow", Err.Number, Err.Description)
    
    Err.Clear
    
End Function
Public Function Flex_ColorCol(Flex As Object, ByVal ForeColor As Long, _
                              ByVal BackColor As Long, ByVal Col As Long) As Long
    Dim oRow As Long, oCol As Long, FS As Long
    Dim AB As Boolean
    
    Const flexFillRepeat = 1
    
    On Local Error GoTo Quit
    
    With Flex
        oRow = .Row
        oCol = .Col
        AB = .AllowBigSelection
        FS = .FillStyle
        
        .AllowBigSelection = True
        .FillStyle = flexFillRepeat
        
        .Row = 1
        .Col = Col
        
        .RowSel = .Rows - 1
        .ColSel = Col
        
        .CellBackColor = BackColor
        .CellForecolor = ForeColor
                
        .Row = oRow
        .Col = oCol
        
        .AllowBigSelection = AB
        .FillStyle = FS

        .Refresh
        DoEvents
    End With
    
    Exit Function
    
Quit:
    Flex_ColorCol = Err.Number
    
    Call ERROR(Controls, "Flex_ColorCol", Err.Number, Err.Description)

    Err.Clear
    
End Function
Public Function Flex_Remove(Flex As Object, ByVal Row As Long) As Long

    On Local Error GoTo Quit
    
    If Row > (Flex.Rows - 1) Then Exit Function
    
    On Local Error Resume Next
    
    Flex.RemoveItem Row
    
    If Err.Number <> 0 Then
        Err.Clear
        
        On Local Error GoTo Quit
        
        Flex.Rows = 1
    End If
    
    Exit Function
    
Quit:
    Flex_Remove = Err.Number
    
    Call ERROR(Controls, "Flex_Remove", Err.Number, Err.Description)

    Err.Clear
    
End Function
Public Function Flex_Find(Flex As Object, ByVal Find As String, _
                          Optional FindExact As Boolean = True, _
                          Optional Col As Long = -1, Optional Row As Long = 0, _
                          Optional SearchCompleteFlex As Boolean = False, _
                          Optional ErrorNumber As Long) As Long
    Dim X As Long, sRow As Long, sCol As Long, Index As Long
    Dim R$
    
    On Local Error GoTo Quit
    
    ErrorNumber = 0
    Flex_Find = -1
    
    If Not FindExact Then Find = LCase$(Find)
    
    With Flex
        If Not SearchCompleteFlex Then
            If Col > -1 Then
                For sRow = 1 To .Rows - 1
                    Index = ((sRow * .Cols) + Col)
                    R$ = IIf(FindExact, .TextArray(Index), LCase$(.TextArray(Index)))
                    
                    If R$ = Find Then
                        Flex_Find = sRow
                        
                        Exit Function
                    End If
                Next sRow
            
                Exit Function
            End If
    
            If Row > 0 Then
                For sCol = 0 To .Cols - 1
                    Index = ((Row * .Cols) + sCol)
                    R$ = IIf(FindExact, .TextArray(Index), LCase$(.TextArray(Index)))
                    
                    If R$ = Find Then
                        Flex_Find = sCol
                        
                        Exit Function
                    End If
                Next sCol
            End If
        Else
            For sRow = 1 To .Rows - 1
                X = Flex_Find(Flex, Find, FindExact, , sRow, False)
                
                If X > -1 Then
                    Flex_Find = X
                    
                    Exit Function
                End If
            Next sRow
        End If
    End With
    
    Exit Function
    
Quit:
    ErrorNumber = Err.Number
    Flex_Find = -2
        
    Call ERROR(Controls, "Flex_Find", Err.Number, Err.Description)
        
    Err.Clear
    
End Function
Public Function Flex_DeleteValue(Flex As Object, ByVal Value As String, _
                                 Optional Row As Long = -1, _
                                 Optional FindExact As Boolean = True) As Long
    Dim Index As Long, fStart As Long, fEnd As Long, sRow As Long
    
    On Local Error GoTo Quit
    
    fStart = IIf(Row = -1, 0, Row)
    fEnd = IIf(Row = -1, Flex.Rows, Row)
    
    For sRow = fStart To fEnd
        Index = Flex_Find(Flex, Value, FindExact, sRow, , False)
        If Index > -1 Then Call Flex_Remove(Flex, Index)
    Next sRow
        
    Exit Function
    
Quit:
    Flex_DeleteValue = Err.Number
    
    Call ERROR(Controls, "Flex_DeleteValue", Err.Number, Err.Description)

    Err.Clear
    
End Function
Public Function Flex_ItemExist(Flex As Object, ByVal Value As String, _
                               Optional FindExact As Boolean = True, _
                               Optional ErrorNumber As Long) As Boolean
    Dim sRow As Long
    
    On Local Error GoTo Quit
    
    ErrorNumber = 0
    
    For sRow = 1 To Flex.Rows - 1
        If Flex_RowItemExist(Flex, Value, sRow, FindExact) Then
            Flex_ItemExist = True
            
            Exit Function
        End If
    Next sRow
    
    Exit Function
    
Quit:
    ErrorNumber = Err.Number
    
    Call ERROR(Controls, "Flex_ItemExist", Err.Number, Err.Description)

    Err.Clear
    
End Function
Public Function Flex_ColItemExist(Flex As Object, ByVal Item As String, ByVal Col As Long, _
                                  Optional FindExact As Boolean = True, _
                                  Optional ErrorNumber As Long) As Boolean
    Dim Index As Long
    
    Index = Flex_Find(Flex, Item, FindExact, Col, , False, ErrorNumber)
    Flex_ColItemExist = (Index > -1)
    
End Function
Public Function Flex_RowItemExist(Flex As Object, ByVal Value As String, ByVal Row As Long, _
                                  Optional FindExact As Boolean = True, _
                                  Optional ErrorNumber As Long) As Boolean
    Dim Index As Long
    
    Index = Flex_Find(Flex, Value, FindExact, , Row, False, ErrorNumber)
    Flex_RowItemExist = (Index > -1)
    
End Function
Public Function Flex_Autosize(Flex As Object, _
                              Optional SingleColSize As Boolean = True) As Long
    Dim frm As New MyControls
    Dim Spalte As Long
    Dim Zeile As Integer
    Dim Breite As Double
    Dim oRd As Boolean
    Dim Lbl As Label
  
    On Local Error GoTo Quit
  
    Load frm
    frm.Tag = "Flex_Autosize"
    
    Set Lbl = frm.LabelMessage
  
    With Flex
        oRd = .Redraw
    
        Lbl.Font = .Font
        Lbl.FontSize = .Font.Size
        Lbl.FontItalic = .Font.Italic
        Lbl.FontBold = .Font.Bold
        Lbl.AutoSize = True
              
        .Redraw = False
      
        For Spalte = 0 To .Cols - 1
            If SingleColSize Then Breite = 0
      
            For Zeile = 0 To .Rows - 1
                Lbl.Caption = .TextMatrix(Zeile, Spalte)
                If Lbl.Width > Breite Then Breite = Lbl.Width
            Next Zeile
      
            If SingleColSize Then .ColWidth(Spalte) = Breite
        Next Spalte
        
        If Not SingleColSize Then
            For Spalte = 0 To .Cols - 1
                .ColWidth(Spalte) = Breite
            Next Spalte
        End If

        .Redraw = oRd
    End With

Quit:
    Flex_Autosize = Err.Number
    
    If Err.Number <> 0 Then Call ERROR(Controls, "Flex_Autosize", Err.Number, Err.Description)
    
    Unload frm
    
    Set frm = Nothing
    Set Lbl = Nothing

    Err.Clear
    
End Function
Public Function PictureBox_FadingText(PictureBox As Object, ByVal TEXT As String, _
                                      ByVal FadeTextColorStart As Long, _
                                      ByVal FadeTextColorEnd As Long, _
                                      Optional Font As StdFont) As Long
    Dim frm As New MyControls
    Dim P As Long, DestCX As Long, DestCY As Long, TmpBackColor As Long
    
    Const SRCINVERT = &H660046
    Const SRCAND = &H8800C6

    On Local Error GoTo Quit
    
    Load frm
    
    With frm
        .Tag = "PictureBox_FadingText"
        .ScaleMode = PictureBox.Parent.ScaleMode
    
        For P = 1 To 3
            .PicFade(P).AutoRedraw = True
            .PicFade(P).ScaleMode = PictureBox.ScaleMode
            .PicFade(P).Width = PictureBox.Width
            .PicFade(P).Height = PictureBox.Height
        
            .PicFade(P).ScaleMode = vbTwips
        Next P
        
        .ScaleMode = vbTwips
        
        If Font Is Nothing Then
            Set Font = New StdFont
            
            Font.Name = "Times New Roman"
            Font.Size = 36
            Font.Bold = True
        End If
        
        Set .PicFade(1).Font = Font
        Set .PicFade(3).Font = .PicFade(1).Font

        Call DLL.FORMS.Fade(.PicFade(2), FadeTextColorStart, FadeTextColorEnd)

        With .PicFade(1)
            .Cls
            .BackColor = vbWhite
            .ForeColor = vbBlack
            
            frm.PicFade(1).Print TEXT
        End With
     
        With .PicFade(3)
            DestCX = .Width / Screen.TwipsPerPixelX
            DestCY = .Height / Screen.TwipsPerPixelY

            .Cls
          
            TmpBackColor = .BackColor
            SetBKColor .hDC, frm.PicFade(1).BackColor
          
            BitBlt .hDC, 0, 0, DestCX, DestCY, frm.PicFade(2).hDC, 0, 0, SRCINVERT
            BitBlt .hDC, 0, 0, DestCX, DestCY, frm.PicFade(1).hDC, 0, 0, SRCAND
            BitBlt .hDC, 0, 0, DestCX, DestCY, frm.PicFade(2).hDC, 0, 0, SRCINVERT
          
            SetBKColor .hDC, TmpBackColor
          
            .Refresh
            DoEvents
            
            Set PictureBox.Picture = .Image
            PictureBox.Refresh
        End With
    End With
    
Quit:
    PictureBox_FadingText = Err.Number
    
    If Err.Number <> 0 Then Call ERROR(Controls, "PictureBox_FadingText", Err.Number, Err.Description)

    Unload frm
    Set frm = Nothing
    
    Err.Clear
    
End Function
Public Function Label_GetTextDimensions(Label As Object, _
                                        Dimension As CONTROLDIMENSIONS) As Long
    Dim R As RECT
  
    On Local Error GoTo Quit
  
    Call DrawText(Label.Parent.hDC, CStr(Label.Caption), -1, R, DT_CALCRECT)
    
    Dimension.Height = R.Bottom
    Dimension.Width = R.Right
    
    Exit Function
    
Quit:
    Label_GetTextDimensions = Err.Number
    
    Call ERROR(Controls, "Label_GetTextDimensions", Err.Number, Err.Description)

    Err.Clear
    
End Function
Public Function PictureBox_ScrollText(PictureBox As Object, ByVal TEXT As String, _
                                      FadeColor As RGBCOLOR) As Long
    Dim frm As New frmCredits
    
    On Local Error GoTo Quit
    
    Load frm
    frm.Tag = "PictureBox_ScrollText"
    
    PictureBox_ScrollText = frm.SetScroll(PictureBox, TEXT, FadeColor)
    
    If PictureBox_ScrollText <> 0 Then
        Unload frm
        
        Exit Function
    End If
    
Quit:
    PictureBox_ScrollText = Err.Number
    
    If Err.Number <> 0 Then Call ERROR(Controls, "PictureBox_ScrollText", Err.Number, Err.Description)

    Set frm = Nothing
    
    Err.Clear
    
End Function
Public Function PictureBox_Fade(PictureBox As Object, ByVal FadeFromColor As Long, _
                                ByVal FadeToColor As Long) As Long
    
    PictureBox_Fade = DLL.FORMS.Fade(PictureBox, FadeFromColor, FadeToColor, , _
                                     cdHorizontal)

End Function
Public Function PictureBox_SaveJPG(Picture As StdPicture, ByVal File As String, _
                                   Optional ByVal Quality As Byte = 255) As Long
    Dim tSI As GdiplusStartupInput
    Dim lRes As Long, lGDIP As Long, lBitmap As Long

    On Local Error GoTo Quit

    tSI.GdiplusVersion = 1
    lRes = GdiplusStartup(lGDIP, tSI)
   
    If lRes = 0 Then
        lRes = GdipCreateBitmapFromHBITMAP(Picture.Handle, 0, lBitmap)
   
        If lRes = 0 Then
            Dim tJpgEncoder As GUID
            Dim tParams As EncoderParameters
         
            CLSIDFromString strptr("{557CF401-1A04-11D3-9A73-0000F81EF32E}"), tJpgEncoder
      
            tParams.Count = 1
      
            With tParams.Parameter
                CLSIDFromString strptr("{1D5BE4B5-FA4A-452D-9CDD-5DB35105E7EB}"), .GUID
                .NumberOfValues = 1
                .Type = 4
                .Value = VarPtr(Quality)
            End With
         
            lRes = GdipSaveImageToFile(lBitmap, strptr(File), tJpgEncoder, tParams)
                             
            GdipDisposeImage lBitmap
        End If
      
        GdiplusShutdown lGDIP
    End If
   
    Exit Function
    
Quit:
    PictureBox_SaveJPG = Err.Number

    Call ERROR(Grafic, "PictureSaveJPG", Err.Number, Err.Description)

    Err.Clear
    
End Function
Public Function OptionButton_GetIndex(OptionButton As Object, _
                                      Optional ErrorNumber As Long) As Long
    Dim Index As Long

    On Local Error GoTo Quit

    ErrorNumber = 0
    
    For Index = OptionButton.LBound To OptionButton.UBound
        If OptionButton(Index).Value Then
            OptionButton_GetIndex = Index
            
            Exit For
        End If
    Next Index

    Exit Function
    
Quit:
    ErrorNumber = Err.Number
    OptionButton_GetIndex = -2
        
    Call ERROR(Controls, "OptionButton_GetIndex", Err.Number, Err.Description)
    
    Err.Clear
    
End Function
Public Function Control_AllowResize(Control As Object, _
                                    Optional DeactivateResizing As Boolean = False) _
                                            As Long
    Dim Result As Long
        
    Const SWP_DRAWFRAME = &H20

    On Local Error GoTo Quit
    
    Result = GetWindowLong(Control.hwnd, GWL_STYLE) Or WS_THICKFRAME
    
    If DeactivateResizing Then Result = Result - WS_THICKFRAME
    
    Call SetWindowLong(Control.hwnd, GWL_STYLE, Result)
    Call SetWindowPos(Control.hwnd, Control.Parent.hwnd, 0, 0, 0, 0, _
                      SWP_NOZORDER Or SWP_NOSIZE Or SWP_NOMOVE Or SWP_DRAWFRAME)

    Exit Function
    
Quit:
    Control_AllowResize = Err.Number
    
    Call ERROR(Controls, "TextBox_AllowResize", Err.Number, Err.Description)

    Err.Clear
    
End Function
Public Function CheckBox_AsOptionButton(CheckBox As Object, ByVal Index As Long) As Long
    Dim P As Long
    
    On Local Error GoTo Quit
    
    If CheckBox(Index).Value Then
        For P = CheckBox.LBound To CheckBox.UBound
            If P <> Index Then CheckBox(P).Value = 0
        Next P
    End If
    
    Exit Function
    
Quit:
    CheckBox_AsOptionButton = Err.Number
    
    Call ERROR(Controls, "CheckBox_AsOptionButton", Err.Number, Err.Description)
    
    Err.Clear
    
End Function
Public Function CheckBox_GetStatus(CheckBox As Object, Optional ErrorNumber As Long) _
                                            As Long()
    Dim P As Long, A() As Long, X As Long, Y As Long
    
    On Local Error GoTo Quit
    
    ErrorNumber = 0
    
    Y = CheckBox.UBound
    X = CheckBox.LBound
    
    ReDim A(X To Y)
    
    For P = X To Y
        If CheckBox(P).Value Then
            A(P) = 1
        Else
            A(P) = 0
        End If
    Next P
    
    CheckBox_GetStatus = A
    
    Exit Function
    
Quit:
    ErrorNumber = Err.Number
    
    Call ERROR(Controls, "CheckBox_GetStatus", Err.Number, Err.Description)
    
    Erase A
    CheckBox_GetStatus = A

    Err.Clear

End Function
Public Function CheckBox_GetSelected(CheckBox As Object, Optional ErrorNumber As Long) _
                                            As Long()
    Dim P As Long, X As Long, A() As Long
        
    On Local Error GoTo Quit
    
    ErrorNumber = 0
    X = 0
    
    For P = CheckBox.LBound To CheckBox.UBound
        If CheckBox(P).Value Then
            ReDim Preserve A(X)
            
            A(X) = P
            X = X + 1
        End If
    Next P
    
    CheckBox_GetSelected = A
    
    Exit Function
    
Quit:
    ErrorNumber = Err.Number

    Call ERROR(Controls, "CheckBox_GetSelected", Err.Number, Err.Description)
    
    Erase A
    CheckBox_GetSelected = A
        
    Err.Clear
    
End Function
Public Function Control_Click(Control As Object) As Long
    Dim hwnd As Long
    
    Const BM_CLICK As Long = &HF5&

    On Local Error GoTo Quit

    hwnd = Control.hwnd
    
    Call SendMessage(hwnd, BM_CLICK, 0, 0&)
    
    Exit Function
    
Quit:
    Control_Click = Err.Number
    
    Call ERROR(Controls, "Control_Click", Err.Number, Err.Description)

    Err.Clear
    
End Function
Public Function Control_GetTextSize(Control As Object, Optional ErrorNumber As Long) _
                                            As CONTROLDIMENSIONS
    Dim nText As Long, hObj As Long, hDC As Long, hFont As Long
    Dim CSize As Size
    Dim sText As String
    
    On Local Error GoTo Quit
    
    ErrorNumber = 0
    
    sText = STRING(BUFFER_SIZE, 0)
    nText = GetWindowText(Control.hwnd, sText, BUFFER_SIZE)
    
    If nText > 0 Then
        sText = Left$(sText, nText)
        hDC = GetDC(Control.hwnd)
        
        If hDC <> 0 Then
            hFont = SendMessage(Control.hwnd, WM_GETFONT, &H0&, &H0&)
                       
            If hFont <> 0 Then
                hObj = SelectObject(hDC, hFont)
                               
                If hObj > 0 Then
                    If GetTextExtentPoint(hDC, sText, nText, CSize) <> 0 Then
                        Control_GetTextSize.Width = CSize.cX
                        Control_GetTextSize.Height = CSize.cY
                        
                        Exit Function
                    End If
                End If
                            
                ReleaseDC Control.hwnd, hDC
            End If
        End If
    End If
        
    Exit Function
    
Quit:
    ErrorNumber = Err.Number
    
    Call ERROR(Controls, "Control_GetTextSize", Err.Number, Err.Description)

    Control_GetTextSize.Height = -2
    Control_GetTextSize.Width = -2

    Err.Clear
    
End Function
Public Function Control_AutoSizeByText(Control As Object) As Long
    Dim oS As Long
    Dim CR As CONTROLDIMENSIONS
    
    On Local Error GoTo Quit
    
    CR = Control_GetTextSize(Control)

    With Control
        oS = .Parent.ScaleMode

        .Parent.ScaleMode = vbPixels
        .Height = CR.Height
        .Width = CR.Width
        .Parent.ScaleMode = oS
        
        .Refresh
        DoEvents
    End With
    
    Exit Function
    
Quit:
    Control_AutoSizeByText = Err.Number
    
    Call ERROR(Controls, "Control_AutoSizeByText", Err.Number, Err.Description)

    Err.Clear
    
End Function
Public Function WebBrowser_InsertText(WebBrowser As Object, ByVal TEXT As String) As Long
    On Local Error GoTo Quit
    
    WebBrowser.Document.Body.insertAdjacentHTML "BeforeEnd", TEXT
    
    Exit Function
    
Quit:
    WebBrowser_InsertText = Err.Number
    
    Call ERROR(Controls, "WebBrowser_InsertText", Err.Number, Err.Description)
    
    Err.Clear

End Function
Public Function WebBrowser_Clear(WebBrowser As Object) As Long

    On Local Error GoTo Quit
    
    WebBrowser.Document.Body.innerHTML = ""
    
    Exit Function
    
Quit:
    WebBrowser_Clear = Err.Number
    
    Call ERROR(Controls, "WebBrowser_Clear", Err.Number, Err.Description)
    
    Err.Clear

End Function
Public Function WebBrowser_GetSource(WebBrowser As Object, _
                                     Optional WaitIfBusy As Boolean = False, _
                                     Optional DocumentIndex As Long, _
                                     Optional ErrorNumber As Long) As String
    Dim P As Long
    Dim Source As String
    Dim B As Boolean
    
    On Local Error GoTo Quit
    
    ErrorNumber = 0
    
    B = WebBrowser.Busy
    
    If WaitIfBusy Then
        Do While WebBrowser.Busy
            DoEvents
        Loop
    End If
    
    On Local Error Resume Next
    
    For P = 0 To WebBrowser.Document.All.Length
        Source = WebBrowser.Document.All(P).outerHTML
        
        If Len(Source) Then
            DocumentIndex = P
            WebBrowser_GetSource = Source

            Exit For
        End If
    Next P
    
    Exit Function
    
Quit:
    ErrorNumber = Err.Number
    DocumentIndex = -2
    WebBrowser_GetSource = ""
        
    Call ERROR(Controls, "WebBrowser_GetSource", Err.Number, Err.Description)
        
    Err.Clear
    
End Function
Public Function Control_SetToStatusBar(ByVal hwnd As Long, ByVal StatusBar As Object, _
                                       ByVal Panel As Long, _
                                       Optional XPos As Long = 0, Optional YPos As Long = 0) _
                                            As Long
    Dim cXPos As Long, cYPos As Long
    Dim R As RECT
    
    Const cBorder As Long = 1
    Const SB_GETRECT = (WM_USER + 10)

    On Local Error GoTo Quit
    
    cXPos = XPos / Screen.TwipsPerPixelX
    cYPos = YPos / Screen.TwipsPerPixelY
   
    Call SendMessage(StatusBar.hwnd, SB_GETRECT, Panel - 1, R)
    Call DLL.WINDOW.Set_Parent(hwnd, StatusBar.hwnd)
    
    Call MoveWindow(hwnd, R.Left + cXPos + cBorder, R.Top + cYPos + cBorder, _
                    R.Right - R.Left - cXPos - cBorder, R.Bottom - R.Top - cYPos - cBorder, True)

    Exit Function
    
Quit:
    Control_SetToStatusBar = Err.Number
    
    Call ERROR(Controls, "Control_SetToStatusBar", Err.Number, Err.Description)

    Err.Clear
    
End Function
Public Function Control_SnapShot(Control As Object, Optional ErrorNumber As Long) _
                                        As StdPicture
    Dim hwnd As Long
    Dim pic As StdPicture
    
    On Local Error GoTo Quit
    
    ErrorNumber = 0
    
    hwnd = Control.hwnd
    
    Set pic = DLL.WINDOW.SnapShot(hwnd, ErrorNumber)
    
    If ErrorNumber <> 0 Then
        Set pic = Nothing
        Exit Function
    End If
    
    Set Control_SnapShot = pic
    
Quit:
    If Err.Number <> 0 Then Call ERROR(Controls, "Control_SnapShot", Err.Number, Err.Description)

    Set pic = Nothing

    Err.Clear
    
End Function
Public Function TextBox_SelectText(TextBox As Object, ByVal TEXT As String, _
                                   Optional FullWordOnly As Boolean = True, _
                                   Optional SelectAll As Boolean = False) As Long
    Dim POS As Long, SL As Long, SS As Long
    
    On Local Error GoTo Quit
    
    If SelectAll Then
        SS = 1
        SL = Len(TextBox.TEXT)
    Else
        If FullWordOnly Then
            If Left$(TEXT, 1) <> " " Then TEXT = " " & TEXT
            If Right$(TEXT, 1) <> " " Then TEXT = TEXT & " "
        End If
        
        POS = InStr(TextBox.TEXT, TEXT)
        
        If POS <> 0 Then
            SS = POS
            SL = Len(TEXT)
        End If
    End If
    
    TextBox.SelStart = SS
    TextBox.SelLength = SL
    
    Exit Function
    
Quit:
    TextBox_SelectText = Err.Number
    
    Call ERROR(Controls, "TextBox_SelectText", Err.Number, Err.Description)

    Err.Clear
    
End Function
Public Function Control_CenterOnForm(Control As Object, Form As Object) As Long
    
    On Local Error GoTo Quit
    
    Control.Left = (Form.Width / 2) - (Control.Width / 2)
    Control.Top = (Form.Height / 2) - (Control.Height / 2)
    
    Control.Refresh
    DoEvents
    
    Exit Function
    
Quit:
    Control_CenterOnForm = Err.Number
    
    Call ERROR(Controls, "Control_CenterOnForm", Err.Number, Err.Description)

    Err.Clear
    
End Function
Public Function Control_CenterOnControl(Control1 As Object, Control2 As Object) As Long
    
    On Local Error GoTo Quit
    
    Control1.Left = Control2.Left + (Control2.Width / 2) - (Control1.Width / 2)
    Control1.Top = Control2.Top + (Control2.Height / 2) - (Control1.Height / 2)
    
    Control1.ZOrder
    DoEvents
    
    Exit Function
    
Quit:
    Control_CenterOnControl = Err.Number
    
    Call ERROR(Controls, "Control_CenterOnControl", Err.Number, Err.Description)

    Err.Clear
    
End Function
Public Function DataGrid_ReadDatabase(DataGrid As Object, Recordset As Object, _
                                      Optional ColumnsWidth As Long = 0) As Long
    Dim P As Long
    
    On Local Error GoTo Quit

    Set DataGrid.DataSource = Recordset
    
    If ColumnsWidth <> 0 Then
        For P = 0 To DataGrid.Columns.Count - 1
            DataGrid.Columns(P).Width = ColumnsWidth
        Next P
    End If

    Exit Function
    
Quit:
    DataGrid_ReadDatabase = Err.Number
    
    Call ERROR(Controls, "DataGrid_ReadDataBase", Err.Number, Err.Description)

    Err.Clear
    
End Function
Public Function Flex_ReadDatabase(Flex As Object, Recordset As Object, _
                                  Optional AutoFormat As Boolean = False) As Long
    Dim P As Long, X As Long
    Dim R$
    
    On Local Error Resume Next
    
    Recordset.MoveFirst
    Flex.Clear
    
    Err.Clear
    
    On Local Error Resume Next
    
    If Not Recordset.EOF Then
        Flex.Cols = Recordset.Fields.Count
        Flex.FixedCols = 0
        Flex.Rows = 2
        Flex.FixedRows = 1
        
        For P = 0 To Recordset.Fields.Count - 1
            R$ = Recordset.Fields(P).Name
            Flex.TextMatrix(0, P) = R$
        Next P
    End If
    
    X = 0
    
    Do While Not Recordset.EOF
        If X > 0 Then Flex.Rows = Flex.Rows + 1
        X = 1

        For P = 0 To Recordset.Fields.Count - 1
            R$ = ""
            R$ = Recordset.Fields(P)
            
            If Err.Number <> 94 And Err.Number <> 0 Then GoTo Quit
            
            Err.Clear
            
            Flex.TextMatrix(Flex.Rows - 1, P) = R$
        Next P
        
        Recordset.MoveNext
    Loop
            
    If AutoFormat Then Call DLL.CRTL.Flex_Autosize(Flex)

Quit:
    Flex_ReadDatabase = Err.Number
    
    If Err.Number <> 0 Then Call ERROR(Controls, "Flex_ReadDataBase", Err.Number, Err.Description)

    Err.Clear
    
End Function
Public Function TreeView_Exist(Treeview As Object, _
                               ByVal Find As String, FindIn As TREEVIEWINFO, _
                               Optional FindExact As Boolean = True, _
                               Optional ErrorNumber As Long) As Boolean
    Dim Result As Long
    
    Result = TreeView_Find(Treeview, Find, FindIn, FindExact, ErrorNumber)
    
    If Result > -1 Then TreeView_Exist = True

End Function
Public Function TreeView_Find(Treeview As Object, _
                              ByVal Find As String, FindIn As TREEVIEWINFO, _
                              Optional FindExact As Boolean = True, _
                              Optional ErrorNumber As Long) As Long
    Dim P As Long
    Dim K As String
    
    On Local Error GoTo Quit
    
    ErrorNumber = 0
    TreeView_Find = -1
    
    If Not FindExact Then Find = LCase$(Find)
    
    With Treeview
        For P = 1 To .Nodes.Count
            If FindIn And tvTEXT Then
                K = .Nodes(K).TEXT
                
                If Not FindExact Then K = LCase$(K)
                
                If Find = K Then
                    TreeView_Find = P
                    
                    Exit Function
                End If
            End If

            If FindIn And tvKEY Then
                K = .Nodes(P).Key
                
                If Not FindExact Then K = LCase$(K)
                
                If Find = K Then
                    TreeView_Find = P
                    
                    Exit Function
                End If
            End If
            
            If FindIn And tvTAG Then
                K = .Nodes(P).Tag
                
                If Not FindExact Then K = LCase$(K)
                
                If Find = K Then
                    TreeView_Find = P
                    
                    Exit Function
                End If
            End If
        Next P
    End With
        
    Exit Function
    
Quit:
    ErrorNumber = Err.Number
    TreeView_Find = -2
    
    Call ERROR(Controls, "TreeView_Find", Err.Number, Err.Description)

    Err.Clear
    
End Function
Public Function Control_DuplicateSize(Control1 As Object, Control2 As Object) As Long

    On Local Error GoTo Quit
    
    Control1.Width = Control2.Width
    Control1.Height = Control2.Height
    Control1.Refresh
    
    DoEvents
    
    Exit Function
    
Quit:
    Control_DuplicateSize = Err.Number
    
    Call ERROR(Controls, "Control_DuplicateSize", Err.Number, Err.Description)

    Err.Clear
    
End Function
Public Function Treeview_Save(Treeview As Object, ByVal Filename As String) As Long
    Dim Nodes() As NODEINFO
    Dim FN As Long, P As Long
    
    On Error GoTo Quit

    ReDim Nodes(1 To Treeview.Nodes.Count) As NODEINFO
    
    For P = 1 To Treeview.Nodes.Count
        With Treeview.Nodes(P)
            Nodes(P).TEXT = .TEXT
            Nodes(P).Key = .Key
            Nodes(P).Tag = .Tag
            Nodes(P).Expanded = .Expanded
            Nodes(P).Sorted = .Sorted
            Nodes(P).Selected = .Selected
            
            If InStr(.FullPath, Treeview.PathSeparator) = 0 Then
                Nodes(P).LinkId = 0
            Else
                Nodes(P).LinkId = .Parent.Index
            End If
        End With
    Next P

    FN = FreeFile(0)
    
    Open Filename For Binary As FN
        Put #FN, , CLng(Treeview.Nodes.Count)
        Put #FN, , Nodes()
    Close #FN
    
    Exit Function
    
Quit:
    Treeview_Save = Err.Number
    
    Call ERROR(Controls, "Treeview_Save", Err.Number, Err.Description)

    Err.Clear
    
End Function
Public Function Treeview_Load(Treeview As Object, ByVal Filename As String) As Long
    Dim Nodes() As NODEINFO
    Dim FN As Long, NodeCount As Long, P As Long
    
    Const tvwChild = 4
    
    On Error GoTo Quit

    FN = FreeFile(0)
    
    Open Filename For Binary As FN
        Get #FN, , NodeCount
        ReDim Nodes(1 To NodeCount)
        Get #FN, , Nodes()
    Close #FN

    Treeview.Nodes.Clear

    If NodeCount Then
        For P = 1 To NodeCount
            If Nodes(P).LinkId = 0 Then
                Treeview.Nodes.Add , , Nodes(P).Key, Nodes(P).TEXT
            Else
                Treeview.Nodes.Add Nodes(P).LinkId, tvwChild, Nodes(P).Key, Nodes(P).TEXT
            End If
            
            Treeview.Nodes(Treeview.Nodes.Count).Expanded = Nodes(P).Expanded
            Treeview.Nodes(Treeview.Nodes.Count).Selected = Nodes(P).Selected
            Treeview.Nodes(Treeview.Nodes.Count).Sorted = Nodes(P).Sorted
        Next P
    End If
        
    Exit Function
    
Quit:
    Treeview_Load = Err.Number
    
    Call ERROR(Controls, "Treeview_Load", Err.Number, Err.Description)

    Err.Clear
    
End Function
Public Function CommonDialog(ComDiag As COMMONDIALOGINFO) As String
    Dim pt As PRINTDLG_TYPE
    Dim F As StdFont
    
    With ComDiag
        If .Filter = "" Then .Filter = "Alle Dateien (*.*)" & Chr$(0) & "*.*"
       .Filter = .Filter & Chr$(0) & Chr$(0) & Chr$(0)
       
        Select Case ComDiag.Flags
            Case cdSHOWFONT
                Set F = DLL.DIALOG.FontDlg(0)
                
                If Not F Is Nothing Then CommonDialog = F.Name
            Case cdSHOWOPEN
                CommonDialog = DLL.File.Show_FileDialogOpen(.hwnd, .Filter, .XPos, .YPos)
            Case cdSHOWSAVE
                CommonDialog = DLL.File.Show_FileDialogSave(.hwnd, .Filter, , .XPos, .YPos)
            Case cdSHOWCOLOR
                CommonDialog = DLL.DIALOG.ColorDlg(.hwnd, True)
            Case cdSHOWPRINTER
                pt.Flags = 0
                pt.lStructSize = Len(pt)
                pt.hWndOwner = .hwnd

                Call PrintDlg(pt)
        End Select
    End With
    
End Function
Public Function Control_CompactPath(Control As Object, ByVal Path As String, _
                                    Optional ErrorNumber As Long) As String
    Dim dx As Long, X As Long
    
    On Local Error GoTo Quit
    
    ErrorNumber = 0
    
    dx = Control.Width / Screen.TwipsPerPixelX
        
    Call PathCompactPath(Control.Parent.hDC, Path, dx)
    
    X = InStr(1, Path, Chr$(0))
    
    If X <> 0 Then
        Control_CompactPath = Left$(Path, X - 1)
    Else
        Control_CompactPath = Path
    End If
    
    Exit Function
    
Quit:
    ErrorNumber = Err.Number
    Control_CompactPath = ""
    
    Call ERROR(Controls, "Control_CompactPath", Err.Number, Err.Description)

    Err.Clear
    
End Function
Public Function Control_SetScrollBar(Control As Object, ScrollBar As ControlDirection, _
                                     ByVal Visible As Boolean) As Long

    On Local Error GoTo Quit
    
    Call ShowScrollBar(Control.hwnd, ScrollBar, Visible)
    
    Exit Function
    
Quit:
    Control_SetScrollBar = Err.Number
    
    Call ERROR(Controls, "Control_SetScrollBar", Err.Number, Err.Description)

    Err.Clear
    
End Function
Public Function MultiLineTooltip(Control As Object, ByVal ToolTipText As String, _
                                 ByVal ToolTipTextColor, ByVal ToolTipBackColor As Long, _
                                 ByVal MaxTipWidth As Long, ByVal DelayTime As Long) _
                                        As Long
    Dim hwnd As Long
    
    On Local Error Resume Next
    
    Control.ToolTipText = ""
    Err.Clear
    
    On Local Error GoTo Quit
    
    hwnd = Control.hwnd
    
    Set m_cTT = New clsTooltip

    With m_cTT
        Call .Create(Control.Parent)
        
        .MaxTipWidth = MaxTipWidth
        .DelayTime(ttDelayShow) = DelayTime
        
        Call .SetBKColor(ToolTipBackColor)
        Call .SetTXTColor(ToolTipTextColor)
        
        Call .AddTool(Control)
        
        .ToolText(Control) = ToolTipText
    End With
    
Quit:
    MultiLineTooltip = Err.Number
    
    If Err.Number <> 0 Then Call ERROR(Controls, "MultiLineTooltip", Err.Number, Err.Description)

    Set m_cTT = Nothing
    
    Err.Clear
    
End Function
Public Function TextBox_SetPasswordChar(TextBox As Object, _
                                        Optional PasswordChar As String) As Long
    Dim hwnd As Long, AscII As Long
    
    On Local Error GoTo Quit
    
    hwnd = TextBox.hwnd
    
    If PasswordChar <> "" Then
        AscII = Asc(PasswordChar)
    Else
        AscII = 0
    End If
    
    Call SendMessage(hwnd, EM_SETPASSWORDCHAR, AscII, "")
    
    Exit Function
    
Quit:
    TextBox_SetPasswordChar = Err.Number
    
    Call ERROR(Controls, "TextBox_SetPasswordChar", Err.Number, Err.Description)

    Err.Clear
    
End Function
Public Function Control_Roll(Control As Object, xStart As Long, xEnd As Long, _
                             Direction As ControlDirection, _
                             Optional RollSpeed As Long = 100) As Long
    Dim P As Long, xStep As Long
        
    On Local Error GoTo Quit

    xStep = 1
    If xEnd < xStart Then xStep = -1
        
    For P = xStart To xEnd Step xStep
        Select Case Direction
            Case cdHorizontal: Control.Width = P
            Case cdVertical:   Control.Height = P
        End Select
        
        Wait RollSpeed
    Next P

    Exit Function
    
Quit:
    Control_Roll = Err.Number
    
    Call ERROR(Controls, "Control_Roll", Err.Number, Err.Description)

    Err.Clear
    
End Function
Public Sub Control_Save(Control As Object, Parent As Object, INIpath As String)
    Dim I As String, F As String, A As String, Z As String
    Dim X As Long
    
    On Local Error Resume Next

    I = INIpath
    F = Parent.Name
    Z = F & Control.Name
    
    X = Control.Index
    If Err.Number = 0 Then Z = Z & "(" & X & ")"
    
                                                          A = Z & "Left"
    Call DLL.INI.Write_INI(I, F, A, Control.Left):        A = Z & "Top"
    Call DLL.INI.Write_INI(I, F, A, Control.Top):         A = Z & "Width"
    Call DLL.INI.Write_INI(I, F, A, Control.Width):       A = Z & "Height"
    Call DLL.INI.Write_INI(I, F, A, Control.Height):      A = Z & "Appearance"
    Call DLL.INI.Write_INI(I, F, A, Control.Appearance):  A = Z & "AutoRedraw"
    Call DLL.INI.Write_INI(I, F, A, Control.AutoRedraw):  A = Z & "BackColor"
    Call DLL.INI.Write_INI(I, F, A, Control.BackColor):   A = Z & "BorderStyle"
    Call DLL.INI.Write_INI(I, F, A, Control.BorderStyle): A = Z & "Caption"
    Call DLL.INI.Write_INI(I, F, A, Control.Caption):     A = Z & "Enabled"
    Call DLL.INI.Write_INI(I, F, A, Control.Enabled):     A = Z & "ForeColor"
    Call DLL.INI.Write_INI(I, F, A, Control.ForeColor):   A = Z & "ScaleMode"
    Call DLL.INI.Write_INI(I, F, A, Control.ScaleMode):   A = Z & "Tag"
    Call DLL.INI.Write_INI(I, F, A, Control.Tag):         A = Z & "Visible"
    Call DLL.INI.Write_INI(I, F, A, Control.Visible):     A = Z & "Text"
    Call DLL.INI.Write_INI(I, F, A, Control.TEXT)
    
    Err.Clear
    
End Sub
Public Sub Control_Load(Control As Object, Parent As Object, INIpath As String)
    Dim I As String, F As String, A As String, Z As String
    Dim X As Long
    
    On Local Error Resume Next

    I = INIpath
    F = Parent.Name
    Z = F & Control.Name
    
    X = Control.Index
    If Err.Number = 0 Then Z = Z & "(" & X & ")"
    
                                                     A = Z & "Left"
    Control.Left = DLL.INI.Read_INI(I, F, A):        A = Z & "Top"
    Control.Top = DLL.INI.Read_INI(I, F, A):         A = Z & "Width"
    Control.Width = DLL.INI.Read_INI(I, F, A):       A = Z & "Height"
    Control.Height = DLL.INI.Read_INI(I, F, A):      A = Z & "Appearance"
    Control.Appearance = DLL.INI.Read_INI(I, F, A):  A = Z & "AutoRedraw"
    Control.AutoRedraw = DLL.INI.Read_INI(I, F, A):  A = Z & "BackColor"
    Control.BackColor = DLL.INI.Read_INI(I, F, A):   A = Z & "BorderStyle"
    Control.BorderStyle = DLL.INI.Read_INI(I, F, A): A = Z & "Caption"
    Control.Caption = DLL.INI.Read_INI(I, F, A):     A = Z & "Enabled"
    Control.Enabled = DLL.INI.Read_INI(I, F, A):     A = Z & "ForeColor"
    Control.ForeColor = DLL.INI.Read_INI(I, F, A):   A = Z & "ScaleMode"
    Control.ScaleMode = DLL.INI.Read_INI(I, F, A):   A = Z & "Tag"
    Control.Tag = DLL.INI.Read_INI(I, F, A):         A = Z & "Visible"
    Control.Visible = DLL.INI.Read_INI(I, F, A):     A = Z & "Text"
    Control.TEXT = DLL.INI.Read_INI(I, F, A)
    
    Err.Clear
    
End Sub
Public Function TextBox_Operation(TextBox As Object, OPERATION As TextBoxOperation, _
                                  Optional TextToReplace As String) As Long
    
    TextBox_Operation = DLL.RTF.RTF_Operation(TextBox, OPERATION, TextToReplace)

End Function
Public Function TextBox_Set_TabStopWidth(TextBox As Object, _
                                         NewTabStopWidth As Long) As Long
    
    TextBox_Set_TabStopWidth = DLL.RTF.Set_TabStopWidth(TextBox, NewTabStopWidth)

End Function
Public Function Control_Animate(Control As Object, xStart As ControlAnimatePosition, _
                                xEnd As ControlAnimatePosition) As Long
    Dim S As ControlAnimatePosition
    Dim X() As Long, Y()  As Long, P As Long, M1 As Long, M2 As Long
    
    On Local Error GoTo Quit
    
    ReDim A(1): ReDim X(1): ReDim Y(1)
    
    With Control.Parent
        M1 = (.Width / 2 - Control.Width / 2)
        M2 = (.Height / 2 - Control.Height / 2)
    
        For P = 0 To 1
            If P = 0 Then S = xStart
            If P = 1 Then S = xEnd
        
            Select Case S
                Case caLeftBottom:   X(P) = 0
                                     Y(P) = .Height - Control.Height
                Case caLeftMiddle:   X(P) = 0
                                     Y(P) = M2
                Case caLeftTop:      X(P) = 0
                                     Y(P) = 0
                Case caMiddleBottom: X(P) = M1
                                     Y(P) = .Height - Control.Height
                Case caMiddleMiddle: X(P) = M1
                                     Y(P) = M2
                Case caMiddleTop:    X(P) = M1
                                     Y(P) = 0
                Case caRightBottom:  X(P) = .Width - Control.Width
                                     Y(P) = .Height - Control.Height
                Case caRightMiddle:  X(P) = .Width - Control.Width
                                     Y(P) = M2
                Case caRightTop:     X(P) = .Width - Control.Width
                                     Y(P) = 0
                End Select
        Next P
    End With
    
    Control.Left = X(0)
    Control.Top = Y(0)
    
    If Not Control.Visible Then Control.Visible = True
    
    Do
        If X(1) > X(0) Then X(0) = X(0) + 1
        If X(1) < X(0) Then X(0) = X(0) - 1
    
        If Y(1) > Y(0) Then Y(0) = Y(0) + 1
        If Y(1) < Y(0) Then Y(0) = Y(0) - 1
            
        Control.Left = X(0)
        Control.Top = Y(0)
        
        Wait 50
                  
        If X(1) = X(0) And Y(0) = Y(1) Then Exit Do
    Loop
    
    Exit Function
    
Quit:
    Control_Animate = Err.Number
    
    Call ERROR(Controls, "Control_Animate", Err.Number, Err.Description)

    Err.Clear
    

End Function
Public Function Control_FontGrow(Control As Object, ByVal FontSizeTarget As Long, _
                                 Optional Speed As Long = 50) As Long
    Dim P As Long, xStep As Long, hwnd As Long
    
    On Local Error GoTo Quit
    
    hwnd = Control.Parent.hwnd
    
    xStep = 1
    If FontSizeTarget < Control.Font.Size Then xStep = -1
    
    For P = Control.Font.Size To FontSizeTarget Step xStep
        If DLL.WINDOW.Get_TaskID(hwnd) = 0 Then Exit Function
        
        If P > 0 Then Control.Font.Size = P
        
        Wait (Speed * 100)
    Next P
    
    Exit Function
    
Quit:
    Control_FontGrow = Err.Number
    
    Call ERROR(Controls, "Control_FontGrow", Err.Number, Err.Description)

    Err.Clear

End Function
Public Function ListVew_Sort(ListView As Object, Column As Long, _
                             SortBy As ListViewSort) As Long
    Dim NewSub As Long, P As Long, SortOrder As Long
    Dim Li As Object
    Dim sFormat As String
    
    On Local Error GoTo Quit

    SortOrder = 0
    
    With ListView
        .SortKey = (Column - 1)
        .ColumnHeaders.Add , , "Dummy", 0
        
        NewSub = .ColumnHeaders.Count - 1

        Select Case SortBy
            Case lsSortASCending
                'Nope
            Case lsSortDEScending
                SortOrder = 1
            Case lsSortByDateASCending, lsSortByDateDEScending
                sFormat = "yyyy.mm.dd hh:mm:ss"

                If SortBy = lsSortByDateDEScending Then SortOrder = 1
                
                For P = .ListItems.Count To 1 Step -1
                    Set Li = .ListItems(P)
                
                    If .SortKey <> 0 Then
                        Li.SubItems(NewSub) = Format(CDate(Li.SubItems(Column - 1)), sFormat)
                    Else
                        Li.SubItems(NewSub) = Format(CDate(Li), sFormat)
                    End If
                Next P
            
                .SortKey = NewSub
            Case lsSortByNumASCending, lsSortByNumDEScending
                If SortBy = lsSortByNumDEScending Then SortOrder = 1
                                
                For P = .ListItems.Count To 1 Step -1
                    Set Li = .ListItems(P)
                
                    If .SortKey <> 0 Then
                        Li.SubItems(NewSub) = Right(Space(20) & Li.SubItems(Column - 1), 20)
                    Else
                        Li.SubItems(NewSub) = Right(Space(20) & Li, 20)
                    End If
                Next P
            
                .SortKey = NewSub
            Case Else
                Exit Function
        End Select
        
        .SortOrder = SortOrder
        .Sorted = True
        .ColumnHeaders.Remove .ColumnHeaders.Count
        
        .Refresh
        DoEvents
    End With
    
    Exit Function
    
Quit:
    ListVew_Sort = Err.Number
    
    Call ERROR(Controls, "ListVew_Sort", Err.Number, Err.Description)

    Err.Clear

End Function
Public Function Control_Move(Control As Object, _
                             ByVal XPos As Long, ByVal YPos As Long, _
                             ByVal Speed As Long) As Long
                             
    Control_Move = DLL.FORMS.Move(Control, XPos, YPos, Speed)
    
End Function
Public Function Control_Blink(Control As Object, Optional BlinkCount As Long = 3, _
                              Optional PauseDuration As Long = 500) As Long
    Dim TopParent As Long, Index As Long
    Dim myC As New MyControls
    
    On Local Error GoTo Quit
    
    TopParent = DLL.WINDOW.Get_TopParent(Control.hwnd)
    
    Index = -1
    
    Do While Index = -1
        Index = DLL.FORMS.Find_Form(FORMS, "Control_Blink", ffFormTag, , True)
    
        If Index = -1 Then
            Load myC
            myC.Tag = "Control_Blink"
        End If
    Loop
    
    Call FORMS(Index).SetBlink(Control, BlinkCount, PauseDuration, TopParent)
    
    Exit Function
    
Quit:
    Control_Blink = Err.Number
    
    Call ERROR(Controls, "Control_Blink", Err.Number, Err.Description)
    
    Err.Clear
    
End Function
Private Sub StartCreateBalloonToolTip(hwndParent As Long)
    Dim hWndTip As Long, dwFlags As Long, ICEx As ICCEX
    
    Const TTS_NOPREFIX As Long = &H2
    Const TTS_BALLOON As Long = &H40
    Const ICC_WIN95_CLASSES As Long = &HFF
    Const TOOLTIPS_CLASSA As String = "tooltips_class32"
    Const CW_USEDEFAULT As Long = &H80000000
    
    dwFlags = TTS_NOPREFIX Or TTS_ALWAYSTIP Or TTS_BALLOON
    
    With ICEx
        .dwSize = Len(ICEx)
        .dwICC = ICC_WIN95_CLASSES
    End With
    
    InitCommonControlsEx ICEx
    
    hWndTip = CreateWindowEx(WS_EX_TOPMOST, TOOLTIPS_CLASSA, "", _
                             WS_POPUP Or dwFlags, CW_USEDEFAULT, CW_USEDEFAULT, _
                             CW_USEDEFAULT, CW_USEDEFAULT, hwndParent, 0, _
                             App.hInstance, ByVal 0&)
    
    If hWndTip = 0 Then Exit Sub
    
    SetWindowPos hWndTip, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOMOVE Or SWP_NOSIZE
    
    ghWndTip = hWndTip
    ghWndParent = hwndParent
    
End Sub
Public Sub Control_CreateBalloonToolTip(hWndOwner As Long, ToolTipText As String)
    Dim tiInfo As TOOLINFO
    Dim hwnd As Long
    
    Const TTF_SUBCLASS As Long = &H10
    Const TTF_TRANSPARENT As Long = &H100
    
    hwnd = DLL.WINDOW.Get_TopParent(hWndOwner)
    Call StartCreateBalloonToolTip(hwnd)
        
    With tiInfo
        .dwFlags = TTF_SUBCLASS Or TTF_TRANSPARENT
        .hwnd = hWndOwner
        .lpszText = strptr(StrConv(ToolTipText, vbFromUnicode))
        .hInst = App.hInstance
        GetClientRect hWndOwner, .rtRect
        
        .cbSize = Len(tiInfo)
    End With
    
    SendMessage ghWndTip, TTM_ADDTOOL, 0&, tiInfo
    
End Sub
Public Function WebBrowser_Print(WebBrowser As Object) As Long

    Const OLECMDID_PRINT = 6
    Const OLECMDEXECOPT_DONTPROMPTUSER = 2
    
    On Local Error GoTo Quit
    
    WebBrowser.ExecWB OLECMDID_PRINT, OLECMDEXECOPT_DONTPROMPTUSER
    
    Exit Function
    
Quit:
    WebBrowser_Print = Err.Number
    
    Call ERROR(Controls, "WebBrowser_Print", Err.Number, Err.Description)
    
    Err.Clear

End Function
Public Function WebBrowser_PrinterPageSetup(WebBrowser As Object) As Long

    Const OLECMDID_PAGESETUP = 8
    Const OLECMDEXECOPT_DODEFAULT = 0

    On Local Error GoTo Quit
    
    WebBrowser.ExecWB OLECMDID_PAGESETUP, OLECMDEXECOPT_DODEFAULT
    
    Exit Function
    
Quit:
    WebBrowser_PrinterPageSetup = Err.Number
    
    Call ERROR(Controls, "WebBrowser_PrinterPageSetup", Err.Number, Err.Description)
    
    Err.Clear

End Function
Public Sub Clipboard_Clear()

    Call OpenClipboard(0&)
    Call EmptyClipboard
    Call CloseClipboard

End Sub
Public Function TextBox_LoadText(TextBox As Object, ByVal File As String) As Long
    Dim R$
    
    On Local Error GoTo Quit
    
    If Not TypeOf TextBox Is TextBox Then
        TextBox_LoadText = -2
        Exit Function
    End If
    
    If Not DLL.File.Exist(File) Then
        TextBox_LoadText = -1
        Exit Function
    End If
    
    R$ = DLL.TEXT.TextFile_Read(File, TextBox_LoadText)

    If TextBox_LoadText <> 0 Then Exit Function

    TextBox.TEXT = R$

    Exit Function
    
Quit:
    TextBox_LoadText = Err.Number
    
    Call ERROR(Controls, "TextBox_LoadText", Err.Number, Err.Description)
    
    Err.Clear
    
End Function
Public Function TextBox_SaveText(TextBox As Object, ByVal File As String, _
                                 Optional OverwriteExisting As Boolean = True) As Long
    
    On Local Error GoTo Quit
    
    If Not TypeOf TextBox Is TextBox Then
        TextBox_SaveText = -2
        Exit Function
    End If

    If DLL.File.Exist(File) Then
        If Not OverwriteExisting Then
            TextBox_SaveText = -1
            Exit Function
        End If
    End If
    
    TextBox_SaveText = DLL.TEXT.TextFile_WriteText(File, TextBox.TEXT)
    
    Exit Function
    
Quit:
    TextBox_SaveText = Err.Number
    
    Call ERROR(Controls, "TextBox_SaveText", Err.Number, Err.Description)
    
    Err.Clear

End Function
Public Function TextBox_WordWrap(ParentForm As Object, TextBox As Object) As Long
    Dim I As Long, j As Long, dPos As Long
    Dim tStr() As String, newStr As String, S As String

    On Local Error GoTo Quit

    tStr() = Split(TextBox.TEXT, vbCrLf)
    
    TextBox.TEXT = vbNullString
    I = 0
    
    Do While I <= UBound(tStr)
        If ParentForm.TextWidth(tStr(I)) > (TextBox.Width - 36) Then
            j = 1
            newStr = vbNullString
                
            Do While j <= Len(tStr(I))
                S = vbNullString
                
                Do While ParentForm.TextWidth(S) < (TextBox.Width - 36) And j <= Len(tStr(I))
                    S = S & mID$(tStr(I), j, 1)
                    j = j + 1
                Loop
                    
                If newStr <> vbNullString Then
                    dPos = InStrRev(S, " ")
                    
                    If dPos > 0 Then
                        j = j - Len(S) + dPos
                        newStr = newStr & mID$(S, 1, dPos) & vbCr & vbCr & vbLf
                    Else
                        newStr = newStr & S & vbCr & vbCr & vbLf
                    End If
                Else
                    dPos = InStrRev(S, " ")
                        
                    If dPos > 0 Then
                        j = j - Len(S) + dPos
                        newStr = newStr & mID$(S, 1, dPos) & vbCrLf
                    Else
                        newStr = newStr & S & vbCrLf
                    End If
                End If
            Loop
                
            TextBox.TEXT = TextBox.TEXT & newStr
        Else
            If I = UBound(tStr) And tStr(I) = vbNullString Then
                TextBox.TEXT = TextBox.TEXT & tStr(I)
            Else
                TextBox.TEXT = TextBox.TEXT & tStr(I) & vbCrLf
            End If
        End If
        
        I = I + 1
    Loop

    Exit Function
    
Quit:
    TextBox_WordWrap = Err.Number
    
    Call ERROR(Controls, "TextBox_WordWrap", Err.Number, Err.Description)
    
    Err.Clear
    
End Function
Public Function Control_MakeTransparent(Control As Object) As Boolean
    Dim lngRegion As Long, lngBackColor As Long, lngHeight As Long
    Dim lngWidth As Long, lnghWnd As Long
    Dim rcRect As RECT
    
    Const RDW_INVALIDATE As Long = &H1
    
    On Local Error Resume Next
    
    If Control.hwnd = 0 Then Exit Function
    If Err.Number = 438 Then Exit Function
        
    lnghWnd = Control.hwnd
    
    Call GetWindowRect(lnghWnd, rcRect)
    
    lngHeight = rcRect.Bottom - rcRect.Top
    lngWidth = rcRect.Right - rcRect.Left
    
    If lngHeight > 0 Or lngWidth > 0 Then
        Call OleTranslateColor(Control.BackColor, 0, lngBackColor)
        lngRegion = RegionFromBitmap(lnghWnd, lngHeight, lngWidth, lngBackColor)
        
        If lngRegion = 0 Then
            'Nope
        Else
            If SetWindowRgn(lnghWnd, lngRegion, True) = 1 Then
                If RedrawWindow(lnghWnd, ByVal 0&, ByVal 0&, RDW_INVALIDATE) = 0 Then
                    'Nope
                Else
                    Control_MakeTransparent = True
                End If
            Else
                'Nope
            End If
        End If
        
        DeleteObject lngRegion
    Else
        Control_MakeTransparent = False
    End If
    
End Function
Private Function RegionFromBitmap(ByVal lnghWnd As Long, ByVal lngH As Long, ByVal lngW As Long, ByVal lngTransColor As Long) As Long
    Dim lngRetr As Long, lngHeight As Long, lngWidth As Long, lngRgnFinal As Long
    Dim lngRgnTmp As Long, lngStart As Long, X As Long, Y As Long, hDC As Long
    Dim iBitmap As Long, BWidth As Long, BHeight As Long, iDC As Long
    Dim PicBits() As Byte
    Dim bi24BitInfo As BITMAPINFO

    hDC = GetDC(lnghWnd)
    
    lngWidth = lngW
    lngHeight = lngH - 1

    BWidth = (lngW \ 4) * 4 + 4
    BHeight = lngH

    With bi24BitInfo.bmiHeader
        .biBitCount = 24
        .biCompression = BI_RGB
        .biPlanes = 1
        .biSize = Len(bi24BitInfo.bmiHeader)
        .biWidth = BWidth
        .biHeight = BHeight + 1
    End With
    
    ReDim PicBits(0 To bi24BitInfo.bmiHeader.biWidth * 3 - 1, 0 To bi24BitInfo.bmiHeader.biHeight - 1)
    
    iDC = CreateCompatibleDC(hDC)
    iBitmap = CreateDIBSection(iDC, bi24BitInfo, DIB_RGB_COLORS, ByVal 0&, ByVal 0&, ByVal 0&)
    
    Call SelectObject(iDC, iBitmap)
    Call BitBlt(iDC, 0, 0, bi24BitInfo.bmiHeader.biWidth, bi24BitInfo.bmiHeader.biHeight, hDC, 0, 0, vbSrcCopy)
    Call GetDIBits(hDC, iBitmap, 0, bi24BitInfo.bmiHeader.biHeight, PicBits(0, 0), bi24BitInfo, DIB_RGB_COLORS)
    Call DeleteDC(iDC)
    Call DeleteObject(iBitmap)

    lngRgnFinal = CreateRectRgn(0, 0, 0, 0)
    
    For Y = 0 To lngHeight
        X = 0
        
        Do While X < lngWidth
            Do While X < lngWidth And RGB(PicBits(X * 3 + 2, lngHeight - Y + 1), _
                                          PicBits(X * 3 + 1, lngHeight - Y + 1), _
                                          PicBits(X * 3, lngHeight - Y + 1)) = lngTransColor
                X = X + 1
            Loop
            
            If X <= lngWidth Then
                lngStart = X
                
                Do While X < lngWidth And RGB(PicBits(X * 3 + 2, lngHeight - Y + 1), _
                                              PicBits(X * 3 + 1, lngHeight - Y + 1), _
                                              PicBits(X * 3, lngHeight - Y + 1)) <> lngTransColor
                    X = X + 1
                Loop
                
                If X + 1 > lngWidth Then X = lngWidth
                
                lngRgnTmp = CreateRectRgn(lngStart, Y, X, Y + 1)
                lngRetr = CombineRgn(lngRgnFinal, lngRgnFinal, lngRgnTmp, RGN_OR)
                
                DeleteObject lngRgnTmp
            End If
        Loop
    Next Y
    
    RegionFromBitmap = lngRgnFinal
    
End Function
Public Function Control_SetAlignment(Control As Variant, _
                                     Alignment As ALIGMENT) As Long
    Dim dwNewLong As Long, hwnd As Long
    Dim isControl As Boolean
    
    On Local Error GoTo Quit
    
    hwnd = GetHwnd(Control, isControl)
    
    dwNewLong = GetWindowLongA(hwnd, GWL_STYLE)

    Call SetWindowLong(hwnd, GWL_STYLE, dwNewLong Or Alignment)
    
    If isControl Then Control.Refresh
    
    DoEvents
    
    Exit Function
    
Quit:
    Control_SetAlignment = Err.Number
    
    Call ERROR(Controls, "Control_SetAlignment", Err.Number, Err.Description)

    Err.Clear
    
End Function
Public Function PictureBox_SwapPicture(PictureBox1 As Object, _
                                       PictureBox2 As Object) As Long
    Dim pic As StdPicture
    
    On Local Error GoTo Quit
    
    Set pic = PictureBox1.Picture
    PictureBox1.Picture = PictureBox2.Picture
    Set PictureBox2.Picture = pic
    
    PictureBox1.Refresh
    PictureBox2.Refresh
    
    DoEvents
    
    Exit Function
    
Quit:
    PictureBox_SwapPicture = Err.Number
        
    Call ERROR(Controls, "PictureBox_SwapPicture", Err.Number, Err.Description)
        
    Err.Clear
                                       
End Function
Public Function Control_SetToForm(Control As Object, NewForm As Object) As Long

    On Local Error GoTo Quit

    Call DLL.WINDOW.Set_Parent(Control.hwnd, NewForm.hwnd)

    Exit Function

Quit:
    Control_SetToForm = Err.Number
        
    Call ERROR(Controls, "Control_SetToForm", Err.Number, Err.Description)
        
    Err.Clear
                                       

End Function
