VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "System"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Public Type OSinfo
    BootDevice       As String
    BuildNumber      As String
    BuildType        As String
    Windowsversion   As String
    CodeSet          As String
    WindowsDirectory As String
    SystemDirectory  As String
    SystemDrive      As String
    Status           As String
    SerialNumber     As String
    RegisteredUser   As String
    Manufacturer     As String
End Type

Private Type MEMORYSTATUS
    dwLength        As Long
    dwMemoryLoad    As Long
    dwTotalPhys     As Long
    dwAvailPhys     As Long
    dwTotalPageFile As Long
    dwAvailPageFile As Long
    dwTotalVirtual  As Long
    dwAvailVirtual  As Long
End Type

Private Type LUID
    LowPart  As Long
    HighPart As Long
End Type

Public Enum REGISTRYCLEANINFO
    rcRUNMENU = 1
    rcTYPEDURLS = 2
    rcRECENTDOCS = 3
End Enum

Public Enum SERVICECOMMANDINFO
    svcSTART = 1
    svcSTOP = 2
    svcRESUME = 4
    svcPAUSE = 8
End Enum

Private Type TOKEN_PRIVILEGES
    PrivilegeCount As Long
    LuidUDT        As LUID
    Attributes     As Long
End Type

Private Enum SID_NAME_USE
    SidTypeUser = 1
    SidTypeGroup
    SidTypeDomain
    SidTypeAlias
    SidTypeWellKnownGroup
    SidTypeDeletedAccount
    SidTypeInvalid
    SidTypeUnknown
    SidTypeComputer
End Enum

Private Declare Function LookupAccountSidW Lib "advapi32.dll" (ByVal lpSystemName As Long, ByVal lpSid As Long, ByVal lpName As Long, ByRef cchName As Long, ByVal lpReferencedDomainName As Long, ByRef cchReferencedDomainName As Long, ByRef peUse As SID_NAME_USE) As Long
Private Declare Function GetTokenInformation Lib "advapi32.dll" (ByVal TokenHandle As Long, ByVal TokenInformationClass As Long, TokenInformation As Any, ByVal TokenInformationLength As Long, ReturnLength As Long) As Long
Private Declare Function GetUserName Lib "advapi32.dll" Alias "GetUserNameA" (ByVal lpBuffer As String, nSize As Long) As Long
Private Declare Function GetTempPath Lib "kernel32" Alias "GetTempPathA" (ByVal nBufferLength As Long, ByVal lpBuffer As String) As Long
Private Declare Function SHGetPathFromIDList Lib "shell32.dll" Alias "SHGetPathFromIDListA" (ByVal pidl As Long, ByVal pszPath As String) As Long
Private Declare Function GetVersionEx Lib "kernel32" Alias "GetVersionExA" (lpVersionInformation As OSVERSIONINFO) As Long
Private Declare Function LockWorkStationA Lib "user32.dll" Alias "LockWorkStation" () As Long
Private Declare Function GetDC Lib "user32" (ByVal hwnd As Long) As Long
Private Declare Function IsNTAdmin Lib "advpack.dll" (ByVal dwReserved As Long, ByRef lpdwReserved As Long) As Long
Private Declare Function AdjustTokenPrivileges Lib "Advapi32" (ByVal TokenHandle As Long, ByVal DisableAllPrivileges As Long, ByRef NewState As TOKEN_PRIVILEGES, ByVal BufferLength As Long, ByRef PreviousState As Any, ByRef ReturnLength As Any) As Long
Private Declare Function ExitWindowsEx Lib "user32" (ByVal dwOptions As Long, ByVal dwReserved As Long) As Long
Private Declare Function GetCurrentProcess Lib "kernel32" () As Long
Private Declare Function GetVersion Lib "kernel32" () As Long
Private Declare Function LookupPrivilegeValueA Lib "Advapi32" (ByVal lpSystemName As String, ByVal lpName As String, ByRef lpLuid As LUID) As Long
Private Declare Function OpenProcessToken Lib "Advapi32" (ByVal ProcessHandle As Long, ByVal DesiredAccess As Long, ByRef TokenHandle As Long) As Long
Private Declare Function CreateToolhelpSnapshot Lib "kernel32" Alias "CreateToolhelp32Snapshot" (ByVal lFlgas As Long, ByVal lProcessID As Long) As Long
Private Declare Function ProcessFirst Lib "kernel32" Alias "Process32First" (ByVal hSnapshot As Long, uProcess As PROCESSENTRY32) As Long
Private Declare Function ProcessNext Lib "kernel32" Alias "Process32Next" (ByVal hSnapshot As Long, uProcess As PROCESSENTRY32) As Long
Private Declare Function NetUserGetInfo Lib "netapi32.dll" (lpServer As Any, UserName As Byte, ByVal Level As Long, lpBuffer As Long) As Long
Private Declare Function CreateThread Lib "kernel32" (lpThreadAttributes As Any, ByVal dwStackSize As Long, ByVal lpStartAddress As Long, ByVal lParameter As Long, ByVal dwCreationFlags As Long, lpThreadID As Long) As Long
Private Declare Function GetExitCodeThread Lib "kernel32" (ByVal hThread As Long, lpExitCode As Long) As Long
Private Declare Function AddFontResource Lib "gdi32" Alias "AddFontResourceA" (ByVal lpFileName As String) As Long
Private Declare Function RemoveFontResource Lib "gdi32" Alias "RemoveFontResourceA" (ByVal lpFileName As String) As Long
Private Declare Function Process32First Lib "kernel32" (ByVal hSnapshot As Long, lppe As PROCESSENTRY32) As Long
Private Declare Function Process32Next Lib "kernel32" (ByVal hSnapshot As Long, lppe As PROCESSENTRY32) As Long
Private Declare Function GetModuleFileNameExA Lib "psapi.dll" (ByVal hProcess As Long, ByVal hModule As Long, ByVal ModuleName As String, ByVal nSize As Long) As Long
Private Declare Function SHGetSpecialFolderLocation Lib "shell32.dll" (ByVal hWndOwner As Long, ByVal nFolder As Long, pidl As ITEMIDLIST) As Long
Private Declare Function LookupAccountName Lib "advapi32.dll" Alias "LookupAccountNameA" (ByVal lpSystemName As String, ByVal lpAccountName As String, ByRef Sid As Any, ByRef cbSid As Long, ByVal ReferencedDomainName As String, ByRef cbReferencedDomainName As Long, ByRef peUse As Long) As Long
Private Declare Function IsWow64Process Lib "kernel32" (ByVal hProcess As Long, ByRef Wow64Process As Long) As Long

Private Declare Sub GlobalMemoryStatus Lib "kernel32" (lpBuffer As MEMORYSTATUS)
Private Declare Sub ExitThread Lib "kernel32" (ByVal dwExitCode As Long)

Private Const TH32CS_SNAPPROCESS As Long = 2&

Public Type DetailedTimeInfo
    WindowsRunningTime As Date
    WindowsStarts      As Date
    
    Stoptime           As Date
    
    RunningSeconds     As Long
    RunningMinutes     As Long
    RunningHours       As Long
    RunningDays        As Long
End Type

Public Type PROCESSUSERNAMEINFO
    Owner  As String
    Domain As String
End Type
    
Public Type PROCESSINFO
    EXENAME   As String
    PROCESSID As Long
    THREADS   As Long
End Type

Public Type PROCESSOWNER
    EXENAME   As String
    PROCESSID As Long
    Owner     As String
    Domain    As String
End Type

Public Type SERVICEINFO
    ServiceName        As String
    ServiceDisplayName As String
    ServicePathName    As String
    ServiceType        As String
    ServiceStartMode   As String
    ServiceState       As String
    ServiceCanPause    As Boolean
    ServiceCanStop     As Boolean
End Type

Public Type INSTALLEDSOFTWAREINFO
    DISPLAYNAME()     As String
    UNINSTALLSTRING() As String
End Type

Public Type ProcessNFO
    EXE As String
    ID  As Long
End Type

Private Type OSVERSIONINFO
    dwOSVersionInfoSize As Long
    dwMajorVersion      As Long
    dwMinorVersion      As Long
    dwBuildNumber       As Long
    dwPlatformId        As Long
    szCSDVersion        As String * 128
End Type

Private Type PROCESSENTRY32
    dwSize              As Long
    cntUsage            As Long
    th32ProcessID       As Long
    th32DefaultHeapID   As Long
    th32ModuleID        As Long
    cntThreads          As Long
    th32ParentProcessID As Long
    pcPriClassBase      As Long
    dwFlags             As Long
    szexeFile           As String * 260
End Type

Private Type USER_INFO
    usri1_name         As Long
    usri1_password     As Long
    usri1_password_age As Long
    usri1_priv         As Long
    usri1_home_dir     As Long
    usri1_comment      As Long
    usri1_flags        As Long
    usri1_script_path  As Long
End Type

Private Type SID_AND_ATTRIBUTES
    Sid As Long
    Attributes As Long
End Type

Private Type TOKEN_USER
    User As SID_AND_ATTRIBUTES
    Sid(500) As Byte
End Type

Public Enum CHOICEOPTION
    ciENABLE = 0
    ciDISABLE = 1
End Enum

Public Enum REGISTERCOMMAND
    riREGISTER = 0
    riUNREGISTER = 1
End Enum

Public Enum USER_PRIV
    USER_NOT_EXIST = -1
    USER_PRIV_GUEST = 0
    USER_PRIV_USER = 1
    USER_PRIV_ADMIN = 2
End Enum

Public Enum OPERATINGSYSTEM
    osUNKNOWN = 0
    osWindows32s = 1
    osWindows95 = 2
    osWindows98 = 3
    osWindows98SE = 4
    osWindowsNT35x = 5
    osWindowsNT40 = 6
    osWindowsMillenium = 7
    osWindows2000 = 8
    osWindowsXP = 9
    osWindows2003 = 10
    osWindowsNET = osWindows2003
    osWindowsVista = 11
    osWindows7 = 12
End Enum

Public Enum ShutDownType
    sdSHUTDOWN = 1
    sdREBOOT = 2
    sdLOGOFF = 3
End Enum

Public Enum DLLType
    dtNODLL = 0
    dtSTANDARDDLL = 1
    dtACTIVEXDLL = 2
End Enum

Private Type ITEMID
    cb   As Long
    abID As Byte
End Type

Private Type ITEMIDLIST
    mkid As ITEMID
End Type

Public Enum SystemDirectory
    sdUser_Desktop = 0
    sdUser_StartmenuPrograms = 2
    sdUser_OwnFiles = 5
    sdUser_Favorites = 6
    sdUser_AutoStart = 7
    sdUser_RecentDocumets = 8
    sdUser_SendTo = 9
    sdUser_Startmenu = 11
    sdUser_OwnMusic = 13
    sdUser_OwnVideos = 14
    sdUser_Templates = 21
    sdUser_AppData = 26
    sdUser_Printer = 27
    sdUser_TemporaryInternetFiles = 32
    sdUser_Cookies = 33
    sdUser_History = 34
    sdUser_OwnPictures = 39
    sdUser_Profile = 40
    sdUser_CDBurning = 59
    sdUser_QuickLaunch = 1000
    sdUser_Temp = 1100

    sdAllUser_Startmenu = 22
    sdAllUser_Programs = 23
    sdAllUser_AutoStart = 24
    sdAllUser_Desktop = 25
    sdAllUser_Favorites = 31
    sdAllUser_AppData = 35
    sdAllUser_SharedFiles = 43
    sdAllUser_Templates = 45
    sdAllUser_Documents = 46
    sdAllUser_AdminTools = 47
    sdAllUser_OwnMusic = 53
    sdAllUser_OwnPictures = 54
    sdAllUser_Videos = 55
    sdAllUser_Profile = 1001

    sdSystem_Netware = 19
    sdSystem_Fonts = 20
    sdSystem_AppData = 28
    sdSystem_Windows = 36
    sdSystem_WindowsSystem = 37
    sdSystem_Programs = 38
    sdSystem_Resources = 56
    sdSystem_Temp = 1200
    sdSystem_Prefetch = 1300
End Enum

Public Enum CLEANUPINFO
    cuUser_Favorites = 1
    cuUser_RecentDocumets = 2
    cuUser_TemporaryInternetFiles = 3
    cuUser_Cookies = 4
    cuUser_History = 5
    cuUser_Temp = 6
    cuAllUser_Favorites = 7
    cuSystem_Temp = 8
    cuSystem_RecycleBin = 9
    cuSystem_Prefetch = 10
End Enum

Public Enum BootModeConstants
    bmNormal = 0
    bmSafeMode = 1
    bmSafeModeNetwork = 2
    bmUNKNOWN = -1
End Enum

Public Enum SecurityOption
    soTASKMANAGER = 0
    soREGEDIT = 1
    soLOGOFF = 2
    soWINDOWSUPDATE = 3
    soCOMMANDCOM = 4
    soSAVEDESKTOP = 5
    soCONTROLPANEL = 6
    soNETWORKICON = 7
End Enum

Private Const VER_PLATFORM_WIN32_NT = 2

Public Function AutoRun(ByVal Field As String, ByVal EXEpath As String) As Boolean
        
    Const Key = "SOFTWARE\Microsoft\Windows\CurrentVersion\Run"
    
    AutoRun = DLL.REGISTRY.ValueSet(HKEY_LOCAL_MACHINE, Key, Field, EXEpath)
                            
End Function
Public Function Class_GetPath(ByVal Class As String) As String
    Dim strCLSID As String, strFilename As String
    
    If Class_isRegistered(Class) Then
        strCLSID = DLL.REGISTRY.ValueGet(HKEY_CLASSES_ROOT_, Class & "\CLSID", "")
        strFilename = DLL.REGISTRY.ValueGet(HKEY_CLASSES_ROOT_, "CLSID\" & strCLSID & "\InprocServer32", "")
    
        Class_GetPath = strFilename
    End If
    
End Function
Public Function Class_isRegistered(ByVal Class As String) As Boolean
    Class_isRegistered = DLL.REGISTRY.KeyExist(HKEY_CLASSES_ROOT_, Class)
End Function
Public Function Component_Register(ByVal ComponentPath As String, cmd As REGISTERCOMMAND) As Boolean
    Dim sProc As String
    Dim Lib As Long, R1 As Long, R2 As Long, Thread As Long

    Lib = LoadLibrary(ComponentPath)
  
    If Lib Then
        If cmd = riUNREGISTER Then
            sProc = "DllUnregisterServer"
        Else
            sProc = "DllRegisterServer"
        End If
        
        R1 = GetProcAddress(Lib, sProc)
        
        If R1 Then
            Thread = CreateThread(ByVal 0, 0, ByVal R1, ByVal 0, 0, R2)
            
            If Thread Then
                R2 = WaitForSingleObject(Thread, 10000)
                
                If R2 Then
                    Call FreeLibrary(Lib)
                    R2 = GetExitCodeThread(Thread, R2)
                    Call ExitThread(R2)
                    
                    Exit Function
                End If
            End If
        End If
    Else
        GoTo Quit
    End If
  
    Component_Register = True
  
Quit:
    Call CloseHandle(Thread)
    Call FreeLibrary(Lib)

End Function
Public Function Font_Register(ByVal FontPath As String, cmd As REGISTERCOMMAND) As Boolean
    
    Select Case cmd
        Case riREGISTER
            Font_Register = (AddFontResource(FontPath) <> 0)
        Case riUNREGISTER
            Font_Register = (RemoveFontResource(FontPath) <> 0)
        Case Else
            '
    End Select
    
End Function
Public Function Get_BootMode() As BootModeConstants
    
    Const SM_CLEANBOOT = &H43

    Get_BootMode = bmUNKNOWN
    
    If CBool(GetSystemMetrics(SM_CLEANBOOT) = bmNormal) Then
        Get_BootMode = bmNormal
    Else
        If CBool(GetSystemMetrics(SM_CLEANBOOT) = bmSafeMode) Then
            Get_BootMode = bmSafeMode
        Else
            If CBool(GetSystemMetrics(SM_CLEANBOOT) = bmSafeModeNetwork) Then
                Get_BootMode = bmSafeModeNetwork
            End If
        End If
    End If
        
End Function
Public Function Get_ComputerName() As String
    Get_ComputerName = DLL.NET.Get_LocalNetworkName
End Function
Public Function Get_DLLType(DLLpath As String) As DLLType
    Dim nHandle As Long
        
    Get_DLLType = dtNODLL
    nHandle = LoadLibrary(DLLpath)
    
    If nHandle Then
        If CBool(GetProcAddress(nHandle, "DllRegisterServer")) Then
            Get_DLLType = dtACTIVEXDLL
        Else
            Get_DLLType = dtSTANDARDDLL
        End If
        
        Call FreeLibrary(nHandle)
    Else
        Get_DLLType = dtNODLL
    End If

Quit:
    
End Function
Public Function Get_DOScommandPath() As String
    Get_DOScommandPath = Environ$("ComSpec")
End Function
Public Function Get_InstalledSoftware() As INSTALLEDSOFTWAREINFO
    Dim U$, D$, K$
    Dim P As Long, X As Long
    Dim IO As INSTALLEDSOFTWAREINFO
    Dim RK() As REGKEY
    
    Const Key = "SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall"
    
    On Local Error Resume Next
    
    RK = DLL.REGISTRY.EnumKey(HKEY_LOCAL_MACHINE_, Key)

    Debug.Print RK(0).Key
    
    If Err.Number <> 0 Then
        Err.Clear
        Exit Function
    End If
    
    For P = 0 To UBound(RK)
        K$ = Key & "\" & RK(P).Key
        D$ = DLL.REGISTRY.ValueGet(HKEY_LOCAL_MACHINE_, K$, "DisplayName")
    
        If D$ = "" Then
            D$ = DLL.REGISTRY.ValueGet(HKEY_LOCAL_MACHINE_, K$, "QuietDisplayName")
            U$ = DLL.REGISTRY.ValueGet(HKEY_LOCAL_MACHINE_, K$, "QuietUninstallString")
        Else
            U$ = DLL.REGISTRY.ValueGet(HKEY_LOCAL_MACHINE_, K$, "UninstallString")
        End If
        
        If D$ <> "" Then
            ReDim Preserve IO.DISPLAYNAME(X)
            ReDim Preserve IO.UNINSTALLSTRING(X)
            
            IO.DISPLAYNAME(X) = D$
            IO.UNINSTALLSTRING(X) = U$
            
            X = X + 1
        End If
    Next P
    
    Get_InstalledSoftware = IO

Quit:
    
End Function
Public Function Get_LocalUserName() As String
    Dim L As Long, Result As Long
    Dim User As String, UserName As String
  
    User = Space(255)
    L = 255
    Result = GetUserName(User, L)
    
    If Result Then
        UserName = Left$(User, L - 1)
        Get_LocalUserName = Trim$(UserName)
    End If
    
End Function
Public Function Get_ProcessList(Optional GetFullPath As Boolean = False) As PROCESSINFO()
    Dim lSnapshot As Long, nResult As Long
    Dim hProcess As Long, nSize As Long, lRet As Long, X As Long
    Dim uProcess As PROCESSENTRY32
    Dim Str As String, ModuleName As String, GetProcessName As String
    Dim PI() As PROCESSINFO
    
    Static isNT As Boolean, getOS As Boolean
    
    If Not getOS Then
        isNT = isWindowsNT
        getOS = True
    End If
    
    lSnapshot = CreateToolhelpSnapshot(TH32CS_SNAPPROCESS, 0&)

    If isNT Then
        If lSnapshot Then
            uProcess.dwSize = Len(uProcess)
            nResult = ProcessFirst(lSnapshot, uProcess)
    
            Do Until nResult = 0
                Str = mID$(uProcess.szexeFile, 1, InStr(uProcess.szexeFile, Chr$(0)) - 1)
            
                If GetFullPath Then
                    hProcess = OpenProcess(PROCESS_QUERY_INFORMATION Or PROCESS_VM_READ, 0, uProcess.th32ProcessID)
                    ModuleName = Space(MAX_PATH)
                    nSize = 500
                
                    lRet = GetModuleFileNameExA(hProcess, 0, ModuleName, nSize)
                
                    GetProcessName = Left(ModuleName, lRet)
                    lRet = CloseHandle(hProcess)
                    
                    If Len(GetProcessName) Then Str = GetProcessName
                End If
            
                ReDim Preserve PI(X)
                                
                PI(X).EXENAME = Str
                PI(X).PROCESSID = uProcess.th32ProcessID
                PI(X).THREADS = uProcess.cntThreads
                
                X = X + 1
                
                nResult = ProcessNext(lSnapshot, uProcess)
            Loop
        End If
    Else
        If lSnapshot Then
            uProcess.dwSize = Len(uProcess)
            
            nResult = Process32First(lSnapshot, uProcess)
            
            Do While nResult
                Str = StrZToStr(uProcess.szexeFile)
            
                ReDim Preserve PI(X)
                                
                PI(X).EXENAME = Str
                PI(X).PROCESSID = uProcess.th32ProcessID
                
                X = X + 1
                
                nResult = Process32Next(lSnapshot, uProcess)
            Loop
        End If
    End If
    
    Get_ProcessList = PI

Quit:
    Call CloseHandle(lSnapshot)

End Function
Public Sub Get_RegOwner(User As String, Organization As String)
        
    Const Path = "SOFTWARE\Microsoft\Windows NT\CurrentVersion"
    
    User = DLL.REGISTRY.ValueGet(HKEY_LOCAL_MACHINE_, Path, "RegisteredOwner")
    Organization = DLL.REGISTRY.ValueGet(HKEY_LOCAL_MACHINE_, Path, "RegisteredOrganization")

End Sub
Public Function Get_ServicePack() As String
    
    Const Key As String = "SOFTWARE\Microsoft\Windows NT\CurrentVersion"

    If isWindowsNT Then
        Get_ServicePack = DLL.REGISTRY.ValueGet(HKEY_LOCAL_MACHINE_, Key, "CSDVersion")
    End If
    
End Function
Public Function Get_SystemColor() As Variant
    Dim ColorPixel As Long, hDC As Long
    
    Const PLANES = 14
    Const BITSPIXEL = 12

    hDC = GetDC(0)
    
    ColorPixel = GetDeviceCaps(hDC, BITSPIXEL) * GetDeviceCaps(hDC, PLANES)
    
    Get_SystemColor = 2 ^ ColorPixel
    
End Function
Public Function Get_SystemDrive() As String
    Get_SystemDrive = GetDir(Environ("systemdrive"))
End Function
Public Function Get_UserList(Optional SystemUser As Boolean = True, _
                             Optional ErrorNumber As Long) As Variant
    Dim WshNetwork As Object, ADS As Object
    Dim DomainName As String, Us As String, U() As String
    Dim User As Variant
    Dim X As Long
    Dim Add As Boolean
    
    On Local Error GoTo Quit
    
    ErrorNumber = 0
    
    Set WshNetwork = CreateObject("WScript.Network")
    DomainName = WshNetwork.UserDomain
    Set ADS = GetObject("WinNT://" & DomainName)

    ADS.Filter = ARRAY("User")

    For Each User In ADS
        Us = User.Name
        Add = True
        
        If Not SystemUser Then
            If Us = "Administrator" Or Us = "Gast" Or Us = "Hilfeassistent" Or _
               InStr(LCase$(Us), "support") = 1 Then Add = False
        End If
        
        If Add Then
            ReDim Preserve U(X)
            U(X) = Us
                              
            X = X + 1
        End If
    Next User

    Get_UserList = U
    
Quit:
    If Err.Number <> 0 Then
        ErrorNumber = Err.Number
        
        Call ERROR(Sys, "Get_UserList", Err.Number, Err.Description)
    End If
    
    Set ADS = Nothing
    Set WshNetwork = Nothing
    
    Err.Clear
    
End Function
Public Function Get_UserLogInState(Optional User As String = "") As USER_PRIV
    Dim nResult As Long, nBuffer As Long
    Dim UserInfo As USER_INFO
    Dim bServer() As Byte, bUser() As Byte
    
    If Not DLL.SYSTEM.isWindowsNT Then
        Get_UserLogInState = USER_PRIV_ADMIN
        Exit Function
    End If
    
    If User <> "" Then
        bUser = User & vbNullChar
    Else
        bUser = DLL.SYSTEM.Get_LocalUserName & vbNullChar
    End If
    
    bServer = "" & vbNullChar
  
    nResult = NetUserGetInfo(bServer(0), bUser(0), &H1, nBuffer)
  
    If nResult = 0 Then
        CopyMemory UserInfo, ByVal nBuffer, Len(UserInfo)
        NetApiBufferFree nBuffer
    
        Get_UserLogInState = UserInfo.usri1_priv
    Else
        Get_UserLogInState = USER_NOT_EXIST
    End If
  
End Function
Public Function Get_WinVer() As OPERATINGSYSTEM
    Dim udtOS As OSVERSIONINFO

    udtOS.dwOSVersionInfoSize = Len(udtOS)

    Call GetVersionEx(udtOS)

    With udtOS
        Select Case .dwPlatformId
            Case 1
                Select Case .dwMajorVersion
                    Case 4
                        Select Case .dwMinorVersion
                            Case 0:    Get_WinVer = osWindows95
                            Case 10:   Get_WinVer = osWindows98
                            Case 90:   Get_WinVer = osWindowsMillenium
                            Case Else: Get_WinVer = osUNKNOWN
                        End Select
                    Case Else:         Get_WinVer = osUNKNOWN
                End Select
            Case 2
                Select Case .dwMajorVersion
                    Case 3:            Get_WinVer = osWindowsNT35x
                    Case 4:            Get_WinVer = osWindowsNT40
                    Case 5
                
                    Select Case .dwMinorVersion
                        Case 0:        Get_WinVer = osWindows2000
                        Case 1:        Get_WinVer = osWindowsXP
                        Case 2:        Get_WinVer = osWindows2003
                        Case Else:     Get_WinVer = osUNKNOWN
                    End Select
                
                    Case 6
                
                    Select Case .dwMinorVersion
                        Case 0:        Get_WinVer = osWindowsVista
                        Case 1:        Get_WinVer = osWindows7
                        Case Else:     Get_WinVer = osUNKNOWN
                    End Select
            
                    Case Else:         Get_WinVer = osUNKNOWN
                End Select
        End Select
    End With
    
End Function
Public Function is32BitWindows() As Boolean
    is32BitWindows = isWindowsNT
End Function
Public Function isAdmin() As Boolean
    isAdmin = IsNTAdmin(ByVal 0&, ByVal 0&)
End Function
Public Function isWindowsNT() As Boolean
    Dim OSinfo As OSVERSIONINFO

    With OSinfo
        .dwOSVersionInfoSize = Len(OSinfo)
        GetVersionEx OSinfo
        isWindowsNT = (.dwPlatformId = VER_PLATFORM_WIN32_NT)
    End With
  
End Function
Public Function Lock_WorkStation() As Boolean
    Lock_WorkStation = LockWorkStationA
End Function
Public Function Security(sOption As SecurityOption, CHOICE As CHOICEOPTION) As Boolean
    Dim Value As Long
    Dim Key As String, Field As String

    Const Root = basDeclar.HKEY_CURRENT_USER

    If CHOICE <> 0 And CHOICE <> 1 Then Exit Function
    
    Value = CHOICE
    
    Key = "Software\Microsoft\Windows\CurrentVersion\Policies\System"

    Select Case sOption
        Case soTASKMANAGER
            If isWindowsNT Then
                Field = "DisableTaskMgr"
            Else
                If SystemParametersInfo(97, CBool(Value), "1", 0) Then
                    Security = True
                    Exit Function
                End If
            End If
        Case soREGEDIT
            Field = "DisableRegistryTools"
        Case soLOGOFF
            Field = "NoLogOff"
        Case soWINDOWSUPDATE
            Field = "DisableWindowsUpdateAccess"
        Case soCOMMANDCOM
            Key = "Software\Policies\Microsoft\Windows\System"
            If Value = 1 Then Value = 2
            Field = "DisableCMD"
        Case soSAVEDESKTOP
            Key = "Software\Microsoft\Windows\CurrentVersion\Policies\Explorer"
            Field = "NoSaveSettings"
        Case soCONTROLPANEL
            Key = "Software\Microsoft\Windows\CurrentVersion\Policies\Explorer"
            Field = "NoControlPanel"
        Case soNETWORKICON
            Key = "Software\Microsoft\Windows\CurrentVersion\Policies\Explorer"
            Field = "NoNetHood"
        Case Else
            Exit Function
    End Select
    
    Security = DLL.REGISTRY.ValueSet(Root, Key, Field, Value)

Quit:
   
End Function
Public Function Set_ComputerName(ByVal NewName As String) As Boolean
    Set_ComputerName = DLL.NET.Set_LocalNetworkName(NewName)
End Function
Private Function StrZToStr(S As String) As String
    StrZToStr = Left$(S, Len(S) - 1)
    StrZToStr = Replace(StrZToStr, Chr$(0), "")
End Function
Public Function System_Shutdown(Optional Reboot As Boolean, Optional ForceReboot As Boolean = False) As Boolean
    Dim Flags As Long, token As Long
    Dim TP As TOKEN_PRIVILEGES
    
    Const TOKEN_ADJUST_PRIVILEGES = &H20
    Const TOKEN_QUERY = &H8
    Const SE_PRIVILEGE_ENABLED = &H2
    Const EWX_SHUTDOWN = 1
    Const EWX_REBOOT = 2
    Const EWX_FORCE = 4

    If GetVersion() >= 0 Then
        Call OpenProcessToken(GetCurrentProcess(), TOKEN_ADJUST_PRIVILEGES Or TOKEN_QUERY, token)
        Call LookupPrivilegeValueA("", "SeShutdownPrivilege", TP.LuidUDT)
        
        TP.PrivilegeCount = 1
        TP.Attributes = SE_PRIVILEGE_ENABLED
    
        Call AdjustTokenPrivileges(token, False, TP, 0, ByVal 0&, ByVal 0&)
    End If
  
    Flags = EWX_SHUTDOWN Or IIf(Reboot, EWX_REBOOT, EWX_SHUTDOWN)
    Flags = IIf(ForceReboot, Flags Or EWX_FORCE, Flags)
    
    If ExitWindowsEx(Flags, &HFFFF) Then System_Shutdown = True
    
End Function
Public Function SystemDirectory(SysDir As SystemDirectory) As String
    Dim Result As Long, X As Long
    Dim idl As ITEMIDLIST
    Dim Buff As String, Str As String
    
    Const NOERROR = 0

    If SysDir >= 1000 Then
        Select Case SysDir
            Case 1000
                SystemDirectory = SystemDirectory(sdSystem_AppData) & "\Microsoft\Internet Explorer\Quick Launch\"
            Case 1100
                Str = STRING(MAX_PATH, 0)
                Result = GetTempPath(MAX_PATH, Str)
            
                If Result Then SystemDirectory = Left$(Str, InStr(Str, Chr$(0)) - 1)
            Case 1200
                Str = SystemDirectory(sdSystem_Windows)
                SystemDirectory = Str & "Temp"
            Case 1300
                Str = SystemDirectory(sdSystem_Windows)
                SystemDirectory = Str & "Prefetch"
            Case 1001 To 1050
                SystemDirectory = Environ$(SysDir - 1000)
                X = InStr(SystemDirectory, "=")
                SystemDirectory = mID(SystemDirectory, X + 1)
        End Select
    Else
        Result = SHGetSpecialFolderLocation(0, SysDir, idl)
    
        If Result = NOERROR Then
            Buff = Space$(512)
            Result = SHGetPathFromIDList(ByVal idl.mkid.cb, ByVal Buff)
            
            If Result Then SystemDirectory = Buff
        End If
    End If

    SystemDirectory = Replace(SystemDirectory, Chr$(0), "")
    SystemDirectory = Trim$(SystemDirectory)
    SystemDirectory = GetDir(SystemDirectory)

End Function
Public Function TaskIsActive(ByVal EXENAME As String) As Boolean
    Dim PI() As PROCESSINFO
    
    PI = Get_ProcessList
    
    If ProcessFind(PI, EXENAME) > -1 Then TaskIsActive = True
    
End Function
Public Function TerminateTask(ByVal EXENAME As String) As Boolean
    Dim PI() As PROCESSINFO
    Dim Index As Long
    
    PI = Get_ProcessList
    
    Index = ProcessFind(PI, EXENAME)
    
    If Index > -1 Then TerminateTask = DLL.WINDOW.TerminateThread(0, PI(Index).PROCESSID)
    
End Function
Public Function Uninstall(ByVal DestinationDir As String, _
                          Optional FileList As Variant, _
                          Optional RemoveDestinationDir As Boolean = False) As Boolean
    Dim Bat As String, T As String, H As String, Z As String
    Dim F() As String, D() As String, File As String, BatStr As String
    Dim Key As String, Field As String, Value As String
    Dim P As Long
                
    DestinationDir = GetDir(DestinationDir)
    Bat = DestinationDir & "Uninstall.bat"
    
    BatStr = "echo Set Fileattribut " & Bat & vbCrLf & _
             "Attrib -R -A -S -H " & Bat & vbCrLf & _
             "echo Delete " & Bat & vbCrLf & _
             "Del " & Bat & vbCrLf

    If RemoveDestinationDir Then
        If DLL.Directory.Read(DestinationDir, D, F, vbHidden + vbReadOnly + vbSystem) <> 0 Then Exit Function
        
        ReDim FileList(UBound(F))
        
        For P = LBound(F) To UBound(F)
            FileList(P) = F(P)
        Next P
    End If
    
    T$ = ""
    
    If Not DLL.ARRAY.isDIM(FileList) Then
        File = DestinationDir & FileList
        
        T = "echo Set Fileattribut " & File & vbCrLf & _
            "Attrib -R -A -S -H " & File & vbCrLf & _
            "echo Delete " & File & vbCrLf & _
            "Del " & File & vbCrLf
        
        T = T & BatStr
    Else
        For P = LBound(FileList) To UBound(FileList)
            File = DestinationDir & FileList(P)
            
            T = T & "echo Set Fileattribut " & File & vbCrLf & _
                  "Attrib -R -A -S -H " & File & vbCrLf & _
                  "echo Delete " & File & vbCrLf & _
                  "Del " & File & vbCrLf
        Next P
        
        T = T & BatStr
        
        If RemoveDestinationDir Then
            DestinationDir = Left$(DestinationDir, Len(DestinationDir) - 1)
            
            T = T & "Delete Directory " & DestinationDir & vbCrLf & _
                    "RmDir " & DestinationDir & vbCrLf
        End If
    End If
    
    H = "@echo off" & vbCrLf & "cls" & vbCrLf
    
    H = H & "echo Uninstall created by MfDLL" & vbCrLf & vbCrLf & _
            "Created on " & Date & " / " & Time & _
            vbCrLf & _
            vbCrLf & _
            vbCrLf & _
            "echo Uninstall in progress....." & vbCrLf & vbCrLf
    
    H = H & T & _
        "echo." & vbCrLf & _
        "echo." & vbCrLf & _
        "echo." & vbCrLf & _
        "echo Uninstall done." & vbCrLf & _
        "echo Please close this window" & _
        vbCrLf & vbCrLf & _
        "Exit"
            
                   
    If DLL.TEXT.TextFile_WriteText(Bat, H) <> 0 Then Exit Function
    
    Z = DLL.STRING.Get_RandomString(8, True, False, True, False, False)
    
    Key = "SOFTWARE\Microsoft\Windows\CurrentVersion\RunOnce"
    Field = "MfDLL Uninstall (" & Z & ")"
    Value = Bat
            
    If Not DLL.REGISTRY.ValueSet(HKEY_LOCAL_MACHINE_, Key, Field, Value) Then Exit Function
     
    Uninstall = True
    
Quit:
    
End Function
Public Function User_LogOff() As Boolean
    
    Const EWX_LOGOFF = 0

    If ExitWindowsEx(EWX_LOGOFF, &HFFFF) Then User_LogOff = True

End Function
Public Function WindowsIsRunning(DTi As DetailedTimeInfo) As String
    Dim H As Single, M As Single, S As Single, MS As Single
    Dim strH As String, strM As String, strS As String
    Dim strMS As String, R$
    Dim X As Long
    
    MS = GetTickCount()
    MS = MS / 1000
    
    H = Int(MS / 3600)
    MS = MS - H * 3600
    M = Int(MS / 60)
    MS = MS - M * 60
    S = Int(MS)
    MS = Int((MS - S) * 10)
    
    strH = CStr(H)
    strM = Format(CStr(M), "##00")
    strS = Format(CStr(S), "##00")
    strMS = CStr(MS)
    
    WindowsIsRunning = strH & ":" & strM & ":" & strS & ":" & strMS

    With DTi
        .Stoptime = Time
        
        R$ = WindowsIsRunning
        X = InStrRev(R$, ":")
        R$ = mID(R$, 1, X - 1)
        
        .WindowsRunningTime = strH & ":" & strM & ":" & strS
    End With

End Function
Public Function XPstyleSupported() As Boolean
    Dim hLib As Long

    hLib = LoadLibrary("uxtheme.dll")
    
    If hLib <> 0 Then
        XPstyleSupported = True
        FreeLibrary hLib
    End If
    
End Function
Public Function TaskManager_GetTasks() As Long()
    Dim hwnd() As Long, P As Long, H As Long, R() As Long, X As Long
    
    hwnd = DLL.WINDOW.Get_AllHwnd
    
    X = 0
    
    For P = 0 To UBound(hwnd)
        H = hwnd(P)
        
        If (GetWindowLong(H, GWL_EXSTYLE) And WS_EX_APPWINDOW) <> 0 Then
            ReDim Preserve R(X)
            R(X) = H
        
            X = X + 1
        End If
    Next P
    
Quit:
    TaskManager_GetTasks = R
    
End Function
Public Function Get_ProcessUserName(ByVal PROCESSID As Long) As PROCESSUSERNAMEINFO
    Dim hProcessID As Long, hToken As Long, Res As Long, cbBuff As Long, tiLen As Long, cbAcctName As Long, cbDomainName As Long, peUse As Long
    Dim TU As TOKEN_USER
    Dim sAcctName2 As String, sDomainName As String
    Dim PI As PROCESSUSERNAMEINFO
    
    Const ERROR_INSUFFICIENT_BUFFER As Long = 122
    Const TOKEN_READ As Long = &H20008
    Const TokenUser = 1

    hProcessID = OpenProcess(PROCESS_QUERY_INFORMATION Or PROCESS_VM_READ, 0, PROCESSID)
    
    If hProcessID <> 0 Then
        If OpenProcessToken(hProcessID, TOKEN_READ, hToken) = 1 Then
            Res = GetTokenInformation(hToken, TokenUser, ByVal 0, tiLen, cbBuff)
        
            If Res = 0 And cbBuff > 0 Then tiLen = cbBuff
            If cbBuff > Len(TU) Then Exit Function
                      
            Res = GetTokenInformation(hToken, TokenUser, TU, tiLen, cbBuff)
          
            If Res = 1 And tiLen > 0 Then
                Res = LookupAccountSidW(0, TU.User.Sid, 0, cbAcctName, 0, cbDomainName, peUse)
            
                If Res = 0 And Err.LastDllError = ERROR_INSUFFICIENT_BUFFER Then
                    sAcctName2 = Space$(cbAcctName)
                    sDomainName = Space$(cbDomainName)
              
                    Res = LookupAccountSidW(0, TU.User.Sid, strptr(sAcctName2), cbAcctName, strptr(sDomainName), cbDomainName, peUse)
                    
                    PI.Owner = Replace(Trim(sAcctName2), Chr(0), "")
                    PI.Domain = Replace(Trim(sDomainName), Chr(0), "")
                Else
                    Exit Function
                End If
            Else
                Exit Function
            End If
        Else
            Exit Function
        End If
    Else
        Exit Function
    End If
      
    If hToken Then
        CloseHandle hToken
        CloseHandle hProcessID
    Else
        Exit Function
    End If
    
    Get_ProcessUserName = PI
    
Quit:
    
End Function
Public Function Get_ProcessesListWithUsername() As PROCESSOWNER()
    Dim Entry As PROCESSENTRY32
    Dim po() As PROCESSOWNER
    Dim Filename As String
    Dim Result As Long, hSnapshot As Long, X As Long
    Dim PI As PROCESSUSERNAMEINFO
    
    X = 0
    Erase po
    
    hSnapshot = CreateToolhelpSnapshot(TH32CS_SNAPPROCESS, 0)
    If hSnapshot = -1 Then Exit Function
        
    Entry.dwSize = LenB(Entry)
    
    Result = Process32First(hSnapshot, Entry)
    
    Do While Result = 1
        Filename = Left$(Entry.szexeFile, InStr(1, Entry.szexeFile, vbNullChar) - 1)
        PI = Get_ProcessUserName(Entry.th32ProcessID)
      
        If PI.Owner <> "" Then
            ReDim Preserve po(X)
                        
            po(X).Domain = PI.Domain
            po(X).EXENAME = Filename
            po(X).Owner = PI.Owner
            po(X).PROCESSID = Entry.th32ProcessID
            
            X = X + 1
        End If
               
        Result = Process32Next(hSnapshot, Entry)
    Loop
    
    Get_ProcessesListWithUsername = po
    
    CloseHandle hSnapshot

Quit:

End Function
Public Function Get_OSinfo(Optional ErrorNumber As Long) As OSinfo
    Dim WMIClass As Object, Item As Object
    Dim OI As OSinfo
        
    On Local Error GoTo Quit
    
    ErrorNumber = 0
    
    Set WMIClass = GetObject("winmgmts:{impersonationLevel=impersonate}").InstancesOf("win32_operatingsystem")
    
    With OI
        For Each Item In WMIClass
            .BootDevice = Item.BootDevice
            .BuildNumber = Item.BuildNumber
            .BuildType = Item.BuildType
            .Windowsversion = Item.Caption
            .CodeSet = Item.CodeSet
            .WindowsDirectory = Item.WindowsDirectory
            .SystemDirectory = Item.SystemDirectory
            .SystemDrive = Item.SystemDrive
            .Status = Item.Status
            .SerialNumber = Item.SerialNumber
            .RegisteredUser = Item.RegisteredUser
            .Manufacturer = Item.Manufacturer
        Next Item
    End With
    
    Get_OSinfo = OI
    
    Exit Function
    
Quit:
    ErrorNumber = Err.Number
    
    Call ERROR(Sys, "Get_OSinfo", Err.Number, Err.Description)
    
    Err.Clear
    
End Function
Public Function Get_BootDevice() As String
    Dim OI As OSinfo
    Dim ErrorNumber As Long
    
    OI = Get_OSinfo(ErrorNumber)
    
    If ErrorNumber = 0 Then Get_BootDevice = OI.BootDevice
    
End Function
Public Function Get_UserSID(ByVal ComputerName As String, ByVal User As String) As String
    Dim lRet As Long, lSidLength As Long, lPeUse As Long, lRefDomain As Long, X As Long
    Dim bTemp() As Byte
    Dim sRefDomain As String, R$
    
    lRet = LookupAccountName(ComputerName, User, 0, lSidLength, 0, lRefDomain, lPeUse)
    
    If lSidLength > 0 Then
        ReDim bTemp(lSidLength - 1)
        sRefDomain = STRING(lRefDomain - 1, Chr(0))
        lRet = LookupAccountName(ComputerName, User, bTemp(0), lSidLength, sRefDomain, lRefDomain, lPeUse)
        
        If lRet <> 0 Then
            R$ = ""
            
            For X = 0 To UBound(bTemp)
                R$ = R$ & CStr(bTemp(X))
            Next X
            
            Get_UserSID = R$
        End If
    End If
    
End Function
Public Sub SystemCleanUp(Optional CleanUp As CLEANUPINFO, _
                         Optional CleanAll As Boolean = False)
    Dim Dir As String, Dirs() As String, tmp As String, FileList() As String
    Dim P As Long, Index As Long, X As Long
    
    On Local Error Resume Next
    
    If CleanAll Then
        For X = 1 To 10
            Call SystemCleanUp(X, False)
        Next X
        
        Exit Sub
    End If
    
    Select Case CleanUp
        Case 1:    Index = 6
        Case 2:    Index = 8
        Case 3:    Index = 32
        Case 4:    Index = 33
        Case 5:    Index = 34
        Case 6:    Index = 1100
        Case 7:    Index = 31
        Case 8:    Index = 1200
        Case 9:    Call DLL.DESKTOP.RecycleBin_Clear(0, False, False, False)
                   Exit Sub
        Case 10:   Index = 1300

        Case Else: Exit Sub
    End Select
    
    tmp = SystemDirectory(Index)
    Dirs = DLL.Directory.ReadAllSubDirs(tmp, False)
    
    If DLL.ARRAY.isDIM(Dirs) Then
        For P = UBound(Dirs) To 0 Step -1
            Dir = Dirs(P)
        
            Call DLL.Directory.DirectoryDeleteFiles(Dir, FileList, True)
        
            Call RmDir(Dir)
        Next P
    End If
    
    Call DLL.Directory.DirectoryDeleteFiles(tmp, FileList, True)
    
End Sub
Public Function Service_Command(ServiceName As String, Command As SERVICECOMMANDINFO, _
                                Optional ErrorNumber As Long) As Boolean
    Dim objService As Object, colServices As Object, m_objWMI As Object

    On Local Error GoTo Quit

    ErrorNumber = 0
    
    Set m_objWMI = GetObject("winmgmts:{impersonationLevel=impersonate}!\\.\root\cimv2")
    Set colServices = m_objWMI.ExecQuery("Select * from Win32_Service where Name = '" & ServiceName & "'")

    For Each objService In colServices
        Select Case Command
            Case svcRESUME:  objService.ResumeService
            Case svcSTART:   objService.StartService
            Case svcSTOP:    objService.StopService
            Case svcPAUSE:   objService.PauseService
        
            Case Else:       Exit Function
        End Select
    Next
    
    Service_Command = True

Quit:
    If Err.Number <> 0 Then
        ErrorNumber = Err.Number
        
        Call ERROR(Sys, "Service_Command", Err.Number, Err.Description)
    End If
    
    Set objService = Nothing: Set colServices = Nothing: Set m_objWMI = Nothing

    Err.Clear

End Function
Public Function Service_GetInfo(ServiceName As String, _
                                Optional ErrorNumber As Long) As SERVICEINFO
    Dim m_objWMI As Object, colServices As Object, objService As Object
    Dim sI As SERVICEINFO
    
    On Local Error GoTo Quit

    ErrorNumber = 0
    
    Set m_objWMI = GetObject("winmgmts:{impersonationLevel=impersonate}!\\.\root\cimv2")
    Set colServices = m_objWMI.ExecQuery("Select * from Win32_Service where Name = '" & ServiceName & "'")

    For Each objService In colServices
        sI.ServiceName = ServiceName
        sI.ServiceDisplayName = objService.DISPLAYNAME
        sI.ServicePathName = objService.PathName
        sI.ServiceType = objService.ServiceType
        sI.ServiceStartMode = objService.StartMode
        sI.ServiceState = objService.State
        sI.ServiceCanPause = objService.AcceptPause
        sI.ServiceCanStop = objService.AcceptStop
        
        Service_GetInfo = sI
        
        GoTo Quit
    Next

Quit:
    If Err.Number <> 0 Then
        ErrorNumber = Err.Number
        
        Call ERROR(Sys, "Get_ServiceInfo", Err.Number, Err.Description)
    End If
        
    Set m_objWMI = Nothing: Set colServices = Nothing: Set objService = Nothing

    Err.Clear

End Function
Public Function Service_GetNames(Optional ErrorNumber As Long) As String()
    Dim m_objWMI As Object, colServices As Object, objService As Object
    Dim X As Long
    Dim S() As String
    
    On Local Error GoTo Quit
    
    ErrorNumber = 0
    
    Set m_objWMI = GetObject("winmgmts:{impersonationLevel=impersonate}!\\.\root\cimv2")
    Set colServices = m_objWMI.ExecQuery("Select * from Win32_Service")

    X = 0

    For Each objService In colServices
        ReDim Preserve S(X)
        S(X) = objService.Name
    
        X = X + 1
    Next

    Service_GetNames = S

Quit:
    If Err.Number <> 0 Then
        ErrorNumber = Err.Number
        
        Call ERROR(Sys, "Get_ServiceNames", Err.Number, Err.Description)
    End If
    
    Set m_objWMI = Nothing: Set colServices = Nothing: Set objService = Nothing
    
    Err.Clear

End Function
Public Function Get_ProductID() As String
    Dim hKey As Long, K As Long
    Dim RegString As String, R$
    
    Const REGKEY = "SOFTWARE\MICROSOFT\Windows NT\CurrentVersion"

    If RegOpenKeyEx(HKEY_LOCAL_MACHINE, REGKEY, 0, _
                    KEY_ALL_ACCESS + &H100, hKey) = ERROR_SUCCESS Then
        K = 255
        
        RegString = STRING$(K, 0)
            
        If RegQueryValueEx(hKey, "ProductId", 0&, REG_SZ, ByVal RegString, K) = ERROR_SUCCESS Then
            R$ = Left$(RegString, K + (mID$(RegString, K, 1) = Chr$(0)))
        Else
            R$ = "Not Registered"
        End If
        
        Get_ProductID = R$
    End If
    
End Function
Public Function is64BitWindows() As Boolean
    Dim lngReturn As Long
    
    Call IsWow64Process(GetCurrentProcess, lngReturn)

    is64BitWindows = (lngReturn <> 0)
    
End Function
Public Sub SystemChangeMessage()
    
    Const HWND_BROADCAST = &HFFFF&
    Const WM_SETTINGCHANGE = &H1A
    
    Call PostMessage(HWND_BROADCAST, WM_SETTINGCHANGE, 0, 0)

End Sub
Public Function SystemRestore(Optional EnableSystemRestore As Boolean = True) As Long
    Dim Obj As Object
    
    On Local Error GoTo Quit
    
    Set Obj = GetObject("winmgmts://./root/default:SystemRestore")

    If EnableSystemRestore Then
        Obj.Enable ("")
    Else
        Obj.Disable ("")
    End If

    Exit Function
    
Quit:
    SystemRestore = Err.Number
    
    Call ERROR(Sys, "SystemRestore", Err.Number, Err.Description)
    
    Err.Clear

End Function
Public Function SystemConfigurationEditor() As Boolean
    
    SystemConfigurationEditor = DLL.SHELL.Execute("Sysedit", , vbMaximizedFocus)
    
End Function
Public Function Get_WindowsEnvironment() As String()
    Dim X As Long
    Dim E() As String
    
     X = 1
    
    Do Until Environ(X) = ""
        ReDim Preserve E(X - 1)
        E(X - 1) = Environ(X)
        
        X = X + 1
    Loop

    Get_WindowsEnvironment = E

End Function
Public Function TaskManager(Command As CHOICEOPTION) As Boolean

    TaskManager = Security(soTASKMANAGER, Command)

End Function
Public Sub System_ShutdownCancel()
    Dim cmd As String
    
    cmd = "Shutdown -a"
    
    Call DLL.SHELL.ExecuteAndWait(cmd, vbHide)
    
End Sub
Public Sub RegistryCleanUp(Optional Clean As REGISTRYCLEANINFO, _
                           Optional CleanAll As Boolean = False)
    Dim P As Long
    
    If CleanAll Then
        For P = 1 To 3
            Call RegistryCleanUp(P, False)
        Next P
        
        Exit Sub
    End If
    
    Select Case Clean
        Case rcRECENTDOCS
            Call RegDeleteKey(HKEY_CURRENT_USER, "Software\Microsoft\Windows\CurrentVersion\Explorer\ComDlg32\LastVisitedMRU")
        Case rcRUNMENU
            Call RegDeleteKey(HKEY_CURRENT_USER, "Software\Microsoft\Windows\CurrentVersion\Explorer\RunMRU")
        Case rcTYPEDURLS
            Call RegDeleteKey(HKEY_CURRENT_USER, "Software\Microsoft\Internet Explorer\TypedURLs")
    End Select
    
End Sub
Public Function Get_ProcessCount() As Long
    Dim PI() As PROCESSINFO
    
    PI = DLL.SYSTEM.Get_ProcessList(False)
    
    Get_ProcessCount = (UBound(PI) + 1)
    
End Function
Public Function Process_GetThreadsCount(ByVal EXE As String, ByVal EXEpathIsFullPath As Boolean) As Long
    Dim PI() As PROCESSINFO
    Dim Index As Long
    
    PI = DLL.SYSTEM.Get_ProcessList(EXEpathIsFullPath)

    Index = ProcessFind(PI, EXE)
    
    If Index = -1 Then
        Process_GetThreadsCount = -1
    Else
        Process_GetThreadsCount = PI(Index).THREADS
    End If
    
End Function
Public Function Get_PhysicalMemoryStatus(TotalPhysicalMemory As Long, _
                                         AvailablePhysicalMemory As Long)
    Dim MS As MEMORYSTATUS
    
    Call GlobalMemoryStatus(MS)

    TotalPhysicalMemory = (MS.dwTotalPhys / 1024 / 1000)
    AvailablePhysicalMemory = (MS.dwAvailPhys / 1024 / 1000)

End Function
Public Function Get_VirtualMemoryStatus(TotalVirtualMemory As Long, _
                                        AvailableVirtualMemory As Long)
    Dim MS As MEMORYSTATUS
    
    Call GlobalMemoryStatus(MS)

    TotalVirtualMemory = (MS.dwTotalVirtual / 1024 / 1000)
    AvailableVirtualMemory = (MS.dwAvailVirtual / 1024 / 1000)

End Function
Public Function Get_MemoryLoad() As Long
    Dim MS As MEMORYSTATUS
    
    Call GlobalMemoryStatus(MS)
    
    Get_MemoryLoad = MS.dwMemoryLoad
    
End Function
