VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Text"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Public Type TEXTFILEINFO
    CharCount As Long
    LineCount As Long
    WordCount As Long
    FileLen   As Long
    TEXT      As String
End Type

Public Enum ADDTTEXTINFO
    Add_to_Begin = 1
    Add_to_End = 2
End Enum

Public Enum CUTTEXTINFO
    ctiCutFromTop = 1
    ctiCutFromBottom = 2
End Enum

Public Function Text_Print(ByVal TEXT As String) As Long
    
    On Local Error GoTo Quit
    
    Printer.Print TEXT
    Printer.EndDoc
    Printer.KillDoc
    
    Exit Function
    
Quit:
    Text_Print = Err.Number

    Call ERROR(Txt, "Text_Print", Err.Number, Err.Description)
    
    Err.Clear
    
End Function
Public Function Text_PrintBlocksatz(ByVal TEXT As String, _
                                    Optional LeftMargin As Long = 80, _
                                    Optional RightMargin As Long = 80, _
                                    Optional TopMargin As Long = 80) As Long
    Dim S As String, T As String, O As String
    Dim AP As Long, L As Long, n As Long, C As Long, ASM As Long
    Dim V As Variant
        
    On Local Error GoTo Quit
    
    With Printer
        ASM = .ScaleMode
        .ScaleMode = vbTwips
        S = TEXT
        AP = TopMargin
        
        Do While Len(S) > 0
            Do While Len(S) > 0
                If InStr(1, S, " ") > 0 Then
                    T = Left$(S, InStr(1, S, " ") - 1)
                Else
                    T = S
                End If
                
                If .TextWidth(O & " " & T) > (.ScaleWidth - LeftMargin - RightMargin) Then
                    Exit Do
                Else
                    If InStr(1, S, " ") > 0 Then
                        O = O & " " & T
                        S = mID$(S, Len(T) + 2)
                    Else
                        O = O & " " & S
                        S = vbNullString
                    End If
                End If
            Loop
    
            Do
                C = Len(O)
                O = Replace(O, "  ", " ")
            Loop While C > Len(O)
      
            O = Trim(O)
            V = Split(O, " ")
            O = Replace(O, " ", vbNullString)
      
            Do
                If UBound(V) = 0 And Len(S) > 0 Then
                    O = vbNullString
                
                    For C = 1 To Len(V(0))
                        O = O & " " & mID$(V(0), C, 1)
                    Next C
          
                    O = Trim(O)
                    V = Split(O, " ")
                    O = Replace(O, " ", vbNullString)
                ElseIf Len(S) > 0 Then
                    n = .ScaleWidth - LeftMargin - RightMargin
                    n = n - .TextWidth(O)
                    n = n / UBound(V)
            
                    Exit Do
                Else
                    n = .TextWidth(" ")
                    Exit Do
                End If
            Loop
      
            L = LeftMargin
        
            For C = 0 To UBound(V)
                .CurrentX = L
                .CurrentY = AP
             
                Printer.Print V(C)
            
                L = L + .TextWidth(V(C)) + n
            Next C
      
            AP = AP + .TextHeight(O)
            O = vbNullString
        Loop
        
        .ScaleMode = ASM
    End With

    Exit Function
    
Quit:
    Text_PrintBlocksatz = Err.Number

    Call ERROR(Txt, "Text_PrintBlocksatz", Err.Number, Err.Description)
    
    Err.Clear
    
End Function
Public Function TextFile_AddText(ByVal File As String, _
                                 ByVal TEXT As String, Add_To As ADDTTEXTINFO) As Long
    Dim FN As Integer
    Dim Str As String
    
    On Local Error GoTo Quit
    
    Select Case Add_To
        Case Add_to_Begin
            Str = TEXT & vbCrLf & TextFile_Read(File)
            TextFile_AddText = TextFile_WriteText(File, Str)
        Case Add_to_End
            FN = FreeFile
    
            Open File For Append As FN
                Print #FN, TEXT
            Close FN
    End Select
    
    Exit Function
    
Quit:
    TextFile_AddText = Err.Number

    Call ERROR(Txt, "TextFile_AddText", Err.Number, Err.Description)
    
    Err.Clear
    
End Function
Public Function TextFile_GetInfo(ByVal File As String) As TEXTFILEINFO
    Dim AstrData() As String
    Dim ti As TEXTFILEINFO
    
    On Local Error GoTo Quit
    
    If Not DLL.File.Exist(File) Then Exit Function
    
    ti.CharCount = FileLen(File)
    ti.FileLen = ti.CharCount
    ti.LineCount = DLL.TEXT.TextFile_LineCount(File)
    ti.TEXT = DLL.TEXT.TextFile_Read(File)
    AstrData() = Split(ti.TEXT, " ")
    ti.WordCount = UBound(AstrData)
    
    TextFile_GetInfo = ti
    
    Exit Function
        
Quit:
    If Err.Number <> 0 Then Call ERROR(Txt, "TextFile_GetInfo", Err.Number, Err.Description)

    Err.Clear
    
End Function
Public Function TextFile_LineCount(ByVal File As String) As Long
    Dim S() As String
    
    If Not DLL.File.Exist(File) Then
        TextFile_LineCount = -2
        Exit Function
    End If
    
    S = Split(TextFile_Read(File), vbCrLf)
    TextFile_LineCount = UBound(S)
    
End Function
Public Function TextFile_Print(ByVal File As String) As Long
    TextFile_Print = Text_Print(TextFile_Read(File))
End Function
Public Function TextFile_Read(ByVal File As String, _
                              Optional ErrorNumber As Long) As String
    Dim FN As Integer
    
    On Local Error GoTo Quit
    
    ErrorNumber = 0
    
    If Not DLL.File.Exist(File) Then
        ErrorNumber = -1
        Exit Function
    End If
    
    FN = FreeFile()
    
    Open File For Binary Access Read As #FN
        TextFile_Read = Space(LOF(FN))
        Get #FN, , TextFile_Read
    Close #FN
    
    If Right$(TextFile_Read, 2) = vbCrLf Then TextFile_Read = Left$(TextFile_Read, Len(TextFile_Read) - 2)
          
Quit:
    If Err.Number <> 0 Then
        ErrorNumber = Err.Number

        Call ERROR(Txt, "TextFile_Read", Err.Number, Err.Description)
    End If
    
    Close #FN

    Err.Clear
    
End Function
Public Function TextFile_ReadLine(ByVal File As String, ByVal Line As Long) As String
    Dim S$
    
    S$ = TextFile_Read(File)
    TextFile_ReadLine = DLL.STRING.Get_Line(S$, Line)
    
Quit:

End Function
Public Function TextFile_ReadLinesInAray(ByVal File As String, _
                                         Optional SplitAt As String = vbCrLf) As String()
    Dim TEXT As String
    Dim A() As String
        
    TEXT = TextFile_Read(File)
    A = Split(TEXT, SplitAt)
    
    TextFile_ReadLinesInAray = A

Quit:

End Function
Public Function TextFile_RemoveLine(ByVal File As String, ByVal Line As Long) As Long
    Dim A() As String, R$
    Dim P As Long, U As Long
        
    R$ = TextFile_Read(File)
    
    If R$ = "" Then
        TextFile_RemoveLine = -1
        Exit Function
    End If
    
    A = Split(R$, vbCrLf)
    Line = Line - 1
    
    If Line <= UBound(A) And Line > -1 Then
        If DLL.ARRAY.DeleteIndex(A, Line) = 0 Then
            U = DLL.ARRAY.Get_UBound(A)
            R$ = ""
            
            If U > -1 Then
                For P = LBound(A) To UBound(A)
                    R$ = R$ & A(P) & vbCrLf
                Next P
            
                If Len(R$) Then R$ = mID$(R$, 1, Len(R$) - 2)
            End If
            
            Call TextFile_WriteText(File, R$)
        End If
    Else
        TextFile_RemoveLine = -2
    End If

Quit:

End Function
Public Function TextFile_ReplaceText(ByVal File As String, _
                                     ByVal SearchFor As String, _
                                     ByVal ReplaceWith As String) As Boolean
    Dim TEXT As String
        
    TEXT = TextFile_Read(File)
    TEXT = Replace(TEXT, SearchFor, ReplaceWith)
        
    If TextFile_WriteText(File, TEXT) = 0 Then TextFile_ReplaceText = True
    
Quit:
   
End Function
Public Function TextFile_LimitFileSize(ByVal TextFile As String, _
                                       ByVal FileSize As Long, _
                                       CutFrom As CUTTEXTINFO) As Boolean
    Dim TEXT As String
    
    If Not DLL.File.Exist(TextFile) Then Exit Function
    
    TEXT = TextFile_Read(TextFile)
    
    Select Case CutFrom
        Case ctiCutFromBottom
            TEXT = Left$(TEXT, FileSize)
        Case ctiCutFromTop
            TEXT = Right$(TEXT, FileSize)
    End Select
    
    If TextFile_WriteText(TextFile, TEXT) = 0 Then TextFile_LimitFileSize = True
    
End Function
Public Function TextFile_WriteText(ByVal File As String, _
                                   ByVal TEXT As String) As Long
    Dim FN As Integer
        
    On Local Error GoTo Quit
    
    Call DLL.File.fKill(File)
       
    FN = FreeFile
    
    Open File For Output As FN
        Print #FN, TEXT
    Close FN

    Exit Function

Quit:
    TextFile_WriteText = Err.Number

    If Err.Number <> 0 Then Call ERROR(Txt, "TextFile_WriteText", Err.Number, Err.Description)

    Err.Clear
    
End Function
Public Function CRC32FromText(ByVal TEXT As String) As String
    CRC32FromText = CRC32(TEXT)
End Function
Public Function CRC32Validate(ByVal TEXT As String, ByVal CRC32 As String) As Boolean
    Dim T$
    
    T$ = basPModule.CRC32(TEXT)
    If T$ = CRC32 Then CRC32Validate = True

End Function
Public Function CRC32Compare(ByVal Text1 As String, ByVal Text2 As String) As Boolean
    If CRC32(Text1) = CRC32(Text2) Then CRC32Compare = True
End Function
Public Function TextFile_Compare(ByVal TextFile1 As String, ByVal TextFile2 As String, _
                                 Optional ErrorNumber As Long) As Boolean
    Dim T(1) As String
    
    T(0) = TextFile_Read(TextFile1, ErrorNumber)
    If ErrorNumber <> 0 Then Exit Function
    
    T(1) = TextFile_Read(TextFile2, ErrorNumber)
    If ErrorNumber <> 0 Then Exit Function
    
    If T(0) = T(1) Then TextFile_Compare = True
    
End Function
