Attribute VB_Name = "basInputBoxEx"
Option Explicit

Private Declare Function CallNextHookEx Lib "user32" (ByVal hHook As Long, ByVal ncode As Long, ByVal wParam As Long, lParam As Any) As Long
Private Declare Function SetWindowsHookEx Lib "user32" Alias "SetWindowsHookExA" (ByVal idHook As Long, ByVal lpfn As Long, ByVal hmod As Long, ByVal dwThreadId As Long) As Long
Private Declare Function UnhookWindowsHookEx Lib "user32" (ByVal hHook As Long) As Long
Private Declare Function SendDlgItemMessage Lib "user32" Alias "SendDlgItemMessageA" (ByVal hDlg As Long, ByVal nIDDlgItem As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Private Declare Function GetDlgItem Lib "user32.dll" (ByVal hDlg As Long, ByVal nIDDlgItem As Long) As Long


Private Const WH_CBT = 5
Private Const HCBT_ACTIVATE = 5
Private Const HC_ACTION = 0
Private Const ES_NUMBER = &H2000

Private hHook As Long, lMaxLen As Long, lPassChar As Long
Private bNumbersOnly As Boolean

Public Function NewProc(ByVal lngCode As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
    Dim RetVal As Long, lngBuffer As Long, lWnd As Long
    Dim strClassName As String
        
    If lngCode < HC_ACTION Then
        NewProc = CallNextHookEx(hHook, lngCode, wParam, lParam)
        Exit Function
    End If

    strClassName = STRING$(256, " ")
    lngBuffer = 255

    If lngCode = HCBT_ACTIVATE Then
        RetVal = GetClassName(wParam, strClassName, lngBuffer)

        If Left$(strClassName, RetVal) = "#32770" Then
            If lPassChar > 0 Then
                SendDlgItemMessage wParam, &H1324, EM_SETPASSWORDCHAR, lPassChar, &H0
            End If

            If lMaxLen > 0 Then SendDlgItemMessage wParam, &H1324, EM_LIMITTEXT, lMaxLen, &H0
            
            If bNumbersOnly Then
                lWnd = GetDlgItem(wParam, &H1324)
                
                If Not lWnd = 0 Then
                    SetWindowLong lWnd, GWL_STYLE, GetWindowLongA(lWnd, GWL_STYLE) Or ES_NUMBER
                End If
            End If
        End If
    End If

    CallNextHookEx hHook, lngCode, wParam, lParam

End Function
Public Function InputBoxEx(Prompt As String, _
                           Optional Title As String = "", _
                           Optional Default As String = "", _
                           Optional XPos, _
                           Optional YPos, _
                           Optional HelpFile, _
                           Optional Context, _
                           Optional MaxLen As Long = 0, _
                           Optional PasswordChar As String = "", _
                           Optional NumbersOnly As Boolean = False, _
                           Optional ByRef CancelledByUser As Boolean = False) As String
    Dim lngModHwnd As Long, lngThreadID As Long

    hHook = 0
    lMaxLen = 0
    lPassChar = 0
    bNumbersOnly = NumbersOnly
    
    If MaxLen > 0 Then lMaxLen = MaxLen
    
    If Not PasswordChar = "" Then lPassChar = Asc(PasswordChar)
        
    If lPassChar > 0 Or lMaxLen > 0 Or bNumbersOnly = True Then
        lngThreadID = GetCurrentThreadId
        lngModHwnd = GetModuleHandle(vbNullString)
        hHook = SetWindowsHookEx(WH_CBT, AddressOf NewProc, lngModHwnd, lngThreadID)
    End If

    InputBoxEx = InputBox(Prompt, Title, Default, XPos, YPos, HelpFile, Context)

    If Not hHook = 0 Then UnhookWindowsHookEx hHook
        
    CancelledByUser = (strptr(InputBoxEx) = 0)

End Function
